/*********************************************************
** filename:    dsge_filtplot.g
** description: Compare shock processes filtered and Pdata
** update: 08/19/2006
**********************************************************/

new;
closeall;
library user, pgraph;
cls;
outwidth 128;

#include bgg_spec.g;
#include pathspec.g;
#include loaddata.g;

mhrun  = "3";
   #ifos2win
        lpath  = resupath $+ "\\mhrun" $+ mhrun $+ "\\";
   #endif 
  
   #ifunix 
        lpath  = resupath $+ "/mhrun" $+ mhrun $+ "/";
   #endif


/**************************************************************
**         load ZZ(t) Draws from MH Output
***************************************************************/

ozzt  = lpath $+ "zzt.dat";
open fhzzt = ^ozzt for read;

drawrow = readr( fhzzt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhzzt, 1); 

	/* Part 1: Compute the mean of x(i) */

	zztmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		zztblock = readr( fhzzt, nblock );

		zztmean0  = zztmean0 + sumc(zztblock)';
	   ndraws = ndraws + rows(zztblock);

	   eofloop = eof(fhzzt);
	endo;

	zztmean0  = zztmean0'/ndraws;
	closeall fhzzt; 

nobs	 = rows(zztmean0);


/**************************************************************
**         load Z(t) Draws from MH Output
***************************************************************/

ozt  = lpath $+ "zt.dat";
open fhzt = ^ozt for read;

drawrow = readr( fhzt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhzt, 1); 

	/* Part 1: Compute the mean of x(i) */

	ztmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		ztblock = readr( fhzt, nblock );

		ztmean0  = ztmean0 + sumc(ztblock)';
	   ndraws = ndraws + rows(ztblock);

	   eofloop = eof(fhzt);
	endo;

	ztmean0  = ztmean0'/ndraws;
	closeall fhzt; 

nobs	 = rows(ztmean0);
/**************************************************************
**         load eps_zeta(t) Draws from MH Output
***************************************************************/

ozzetat  = lpath $+ "zzetat";
open fhzzetat = ^ozzetat for read;

drawrow = readr( fhzzetat, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhzzetat, 1); 

	/* Part 1: Compute the mean of x(i) */

	zzetatmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		zzetatblock = readr( fhzzetat, nblock );

		zzetatmean0  = zzetatmean0 + sumc(zzetatblock)';
	   ndraws = ndraws + rows(zzetatblock);

	   eofloop = eof(fhzzetat);
	endo;

	zzetatmean0  = zzetatmean0'/ndraws;
	closeall fhzzetat; 

nobs	 = rows(zzetatmean0);


/**************************************************************
**         load zeta(t) Draws from MH Output
***************************************************************/

ozetat  = lpath $+ "zetat";
open fhzetat = ^ozetat for read;

drawrow = readr( fhzetat, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhzetat, 1); 

	/* Part 1: Compute the mean of x(i) */

	zetatmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		zetatblock = readr( fhzetat, nblock );

		zetatmean0  = zetatmean0 + sumc(zetatblock)';
	   ndraws = ndraws + rows(zetatblock);

	   eofloop = eof(fhzetat);
	endo;

	zetatmean0  = zetatmean0'/ndraws;
	closeall fhzetat; 

nobs	 = rows(zetatmean0);
/**************************************************************
**         load eps_mu(t) Draws from MH Output
***************************************************************/

ommut  = lpath $+ "mmut";
open fhmmut = ^ommut for read;

drawrow = readr( fhmmut, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhmmut, 1); 

	/* Part 1: Compute the mean of x(i) */

	mmutmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		mmutblock = readr( fhmmut, nblock );

		mmutmean0  = mmutmean0 + sumc(mmutblock)';
	   ndraws = ndraws + rows(mmutblock);

	   eofloop = eof(fhmmut);
	endo;

	mmutmean0  = mmutmean0'/ndraws;
	closeall fhmmut; 

nobs	 = rows(mmutmean0);



/**************************************************************
**         load mu(t) Draws from MH Output
***************************************************************/

omut  = lpath $+ "mut";
open fhmut = ^omut for read;

drawrow = readr( fhmut, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhmut, 1); 

	/* Part 1: Compute the mean of x(i) */

	mutmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		mutblock = readr( fhmut, nblock );

		mutmean0  = mutmean0 + sumc(mutblock)';
	   ndraws = ndraws + rows(mutblock);

	   eofloop = eof(fhmut);
	endo;

	mutmean0  = mutmean0'/ndraws;
	closeall fhmut; 

nobs	 = rows(mutmean0);

/**************************************************************
**         load eps_lambda(t) Draws from MH Output
***************************************************************/

ollambdat  = lpath $+ "llambdat";
open fhllambdat = ^ollambdat for read;

drawrow = readr( fhllambdat, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhllambdat, 1); 

	/* Part 1: Compute the mean of x(i) */

	llambdatmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		llambdatblock = readr( fhllambdat, nblock );

		llambdatmean0  = llambdatmean0 + sumc(llambdatblock)';
	   ndraws = ndraws + rows(llambdatblock);

	   eofloop = eof(fhllambdat);
	endo;

	llambdatmean0  = llambdatmean0'/ndraws;
	closeall fhllambdat; 

nobs	 = rows(llambdatmean0);


/**************************************************************
**         load lambda(t) Draws from MH Output
***************************************************************/

olambdat  = lpath $+ "lambdat";
open fhlambdat = ^olambdat for read;

drawrow = readr( fhlambdat, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhlambdat, 1); 

	/* Part 1: Compute the mean of x(i) */

	lambdatmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		lambdatblock = readr( fhlambdat, nblock );

		lambdatmean0  = lambdatmean0 + sumc(lambdatblock)';
	   ndraws = ndraws + rows(lambdatblock);

	   eofloop = eof(fhlambdat);
	endo;

	lambdatmean0  = lambdatmean0'/ndraws;
	closeall fhlambdat; 

nobs	 = rows(lambdatmean0);

/**************************************************************
**         load eps_theta(t) Draws from MH Output
***************************************************************/

otthetat  = lpath $+ "tthetat";
open fhtthetat = ^otthetat for read;

drawrow = readr( fhtthetat, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhtthetat, 1); 

	/* Part 1: Compute the mean of x(i) */

	tthetatmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		tthetatblock = readr( fhtthetat, nblock );

		tthetatmean0  = tthetatmean0 + sumc(tthetatblock)';
	   ndraws = ndraws + rows(tthetatblock);

	   eofloop = eof(fhtthetat);
	endo;

	tthetatmean0  = tthetatmean0'/ndraws;
	closeall fhtthetat; 

nobs	 = rows(tthetatmean0);


/**************************************************************
**         load theta(t) Draws from MH Output
***************************************************************/

othetat  = lpath $+ "thetat";
open fhthetat = ^othetat for read;

drawrow = readr( fhthetat, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhthetat, 1); 

	/* Part 1: Compute the mean of x(i) */

	thetatmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		thetatblock = readr( fhthetat, nblock );

		thetatmean0  = thetatmean0 + sumc(thetatblock)';
	   ndraws = ndraws + rows(thetatblock);

	   eofloop = eof(fhthetat);
	endo;

	thetatmean0  = thetatmean0'/ndraws;
	closeall fhthetat; 

nobs	 = rows(thetatmean0);
/**************************************************************
**         load eps_b(t) Draws from MH Output
***************************************************************/

obbt  = lpath $+ "bbt";
open fhbbt = ^obbt for read;

drawrow = readr( fhbbt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhbbt, 1); 

	/* Part 1: Compute the mean of x(i) */

	bbtmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		bbtblock = readr( fhbbt, nblock );

		bbtmean0  = bbtmean0 + sumc(bbtblock)';
	   ndraws = ndraws + rows(bbtblock);

	   eofloop = eof(fhbbt);
	endo;

	bbtmean0  = bbtmean0'/ndraws;
	closeall fhbbt; 

nobs	 = rows(bbtmean0);




/**************************************************************
**         load b(t) Draws from MH Output
***************************************************************/

obt  = lpath $+ "bt";
open fhbt = ^obt for read;

drawrow = readr( fhbt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhbt, 1); 

	/* Part 1: Compute the mean of x(i) */

	btmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		btblock = readr( fhbt, nblock );

		btmean0  = btmean0 + sumc(btblock)';
	   ndraws = ndraws + rows(btblock);

	   eofloop = eof(fhbt);
	endo;

	btmean0  = btmean0'/ndraws;
	closeall fhbt; 

nobs	 = rows(btmean0);




/**************************************************************
**         load eps_r(t) Draws from MH Output
***************************************************************/

ort  = lpath $+ "rt";
open fhrt = ^ort for read;

drawrow = readr( fhrt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhrt, 1); 

	/* Part 1: Compute the mean of x(i) */

	rtmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		rtblock = readr( fhrt, nblock );

		rtmean0  = rtmean0 + sumc(rtblock)';
	   ndraws = ndraws + rows(rtblock);

	   eofloop = eof(fhrt);
	endo;

	rtmean0  = rtmean0'/ndraws;
	closeall fhrt; 

nobs	 = rows(rtmean0);

/**************************************************************
**         load eps_gam(t) Draws from MH Output
***************************************************************/

oggamt  = lpath $+ "ggamt";
open fhggamt = ^oggamt for read;

drawrow = readr( fhggamt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhggamt, 1); 

	/* Part 1: Compute the mean of x(i) */

	ggamtmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		ggamtblock = readr( fhggamt, nblock );

		ggamtmean0  = ggamtmean0 + sumc(ggamtblock)';
	   ndraws = ndraws + rows(ggamtblock);

	   eofloop = eof(fhggamt);
	endo;

	ggamtmean0  = ggamtmean0'/ndraws;
	closeall fhggamt; 

nobs	 = rows(ggamtmean0);


/**************************************************************
**         load gamma(t) Draws from MH Output
***************************************************************/

ogamt  = lpath $+ "gamt";
open fhgamt = ^ogamt for read;

drawrow = readr( fhgamt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhgamt, 1); 

	/* Part 1: Compute the mean of x(i) */

	gamtmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		gamtblock = readr( fhgamt, nblock );

		gamtmean0  = gamtmean0 + sumc(gamtblock)';
	   ndraws = ndraws + rows(gamtblock);

	   eofloop = eof(fhgamt);
	endo;

	gamtmean0  = gamtmean0'/ndraws;
	closeall fhgamt; 

nobs	 = rows(gamtmean0);




/**************************************************************
**         load GG(t) Draws from MH Output
***************************************************************/

oggt  = lpath $+ "gt";
open fhggt = ^oggt for read;

drawrow = readr( fhggt, 1 );	
drawdim = cols( drawrow );	
drawrow = seekr( fhggt, 1); 

	/* Part 1: Compute the mean of x(i) */

	ggtmean0  = zeros(1,drawdim); 

	eofloop = 0;
	nblock  = 10;
	ndraws  = 0;

	do until eofloop; 
		ggtblock = readr( fhggt, nblock );

		ggtmean0  = ggtmean0 + sumc(ggtblock)';
	   ndraws = ndraws + rows(ggtblock);

	   eofloop = eof(fhggt);
	endo;

	ggtmean0  = ggtmean0'/ndraws;
	closeall fhggt; 

/****************************************/

graphset;
 
   begwind;

   margin(0,0,0.2,0.2);
   window(3,3,0);
   fonts("microb");

   _ptitlht = 0.3;
   _paxht = 0.3;
   _pnumht = 0.25;
   _pcolor = {2 4} ;
   _pltype = {6 1};
   _protate = 0; 
   _plctrl = 0;
   _plwidth = 5.5;
   _psymsiz = 5;

   xlabel("Period");
   xtics(1954.75,2006,2.25,1);


title(" Smoothed Neutral Shock: ln(z_t)");
   xy(ti,ztmean0);
   nextwind;
   
   title("Smoothed Investment-Specific Shock");
   xy(ti,zetatmean0);
  nextwind;

   title("Smoothed Price Markup Shock");
   xy(ti,lambdatmean0);
   nextwind;

   title("Smoothed Wage Markup Shock");
   xy(ti,thetatmean0);
   nextwind;

   title("Smoothed Intertemporal Pref Shock");
   xy(ti,btmean0);
   nextwind;

   title("Smoothed MP Shock");
   xy(ti,rtmean0);
   nextwind;

   title("Smoothed Gov Spending Shock");
   xy(ti,ggtmean0);
   nextwind;

   title("Smoothed Wealth Shock");
   xy(ti,gamtmean0);
   nextwind;

   title("Smoothed MU_t");
   xy(ti,mutmean0);

endwind;


/** start log file **/
outstr = resupath $+ "\\smoothed_shocks.log";
output file = ^outstr reset;
"Smoothed ln(mu_t)"~"Smoothed mu_t"~"Smoothed ln(gamma_t)";
ln(mutmean0)~mutmean0~gamtmean0;

/** close log file **/
output file = ^outstr off;

end;
begwind;

   margin(0,0,0.2,0.2);
   window(3,2,0);
   fonts("microb");

   _ptitlht = 0.3;
   _paxht = 0.3;
   _pnumht = 0.25;
   _pcolor = {2 4} ;
   _pltype = {6 1};
   _protate = 0; 
   _plctrl = 0;
   _plwidth = 5.5;
   _psymsiz = 5;

   xlabel("Period");
xtics(1954.75,2006,2.25,1);
 
title("Epsilon Price Markup Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln lambda(t)";*/
   xy(ti,llambdatmean0);
nextwind;

title("Price Markup Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln lambda(t)";*/
   xy(ti,lambdatmean0);
nextwind;
title("Epsilon Wage Markup Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln theta(t)";*/
   xy(ti,tthetatmean0);
nextwind;

title("Wage Markup Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln theta(t)";*/
   xy(ti,thetatmean0);
nextwind;
title("Epsilon Intertemporal Preference Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln theta(t)";*/
   xy(ti,bbtmean0);
nextwind;

title("Intertemporal Preference Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln theta(t)";*/
   xy(ti,btmean0);
endwind;

begwind;

   margin(0,0,0.2,0.2);
   window(2,2,0);
   fonts("microb");

   _ptitlht = 0.3;
   _paxht = 0.3;
   _pnumht = 0.25;
   _pcolor = {12 4} ;
   _pltype = {6 1};
   _protate = 0; 
   _plctrl = 0;
   _plwidth = 5.5;
   _psymsiz = 5;
   xlabel("Period");
xtics(1954.75,2006,2.25,1);
title("Monetary Policy Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed eps_r(t)";*/
   xy(ti,rtmean0);

nextwind;
title("Government Spending Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed eps_r(t)";*/
   xy(ti,ggtmean0);


endwind;

begwind;

   margin(0,0,0.2,0.2);
   window(2,2,0);
   fonts("microb");

   _ptitlht = 0.3;
   _paxht = 0.3;
   _pnumht = 0.25;
   _pcolor = {12 4} ;
   _pltype = {6 1};
   _protate = 0; 
   _plctrl = 0;
   _plwidth = 5.5;
   _psymsiz = 5;
   xlabel("Period");
xtics(1954.75,2006,2.25,1);
   
title("Epsilon Financial Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln mu(t)";*/
   //xy(ti,mmutmean0); 
   xy(ti,mutmean0);
nextwind;

title("Financial Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln mu(t)";*/
   xy(ti,ln(mutmean0));
nextwind;
title("Epsilon Wealth Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln mu(t)";*/
  // xy(ti,ggamtmean0);
xy(ti,mmutmean0); 
nextwind;

title("Wealth Shock");
   /*_plegctl = {2 4 5.5 3.5};
   _plegstr = "Smoothed ln mu(t)";*/
   xy(ti,gamtmean0);

endwind;


end;


