/**************************************************************
 It computes impulse response functions for the DSGE model
*******************************************************************/

new;
closeall;
library pgraph, user;
cls;
outwidth 256;

format /mat /on /mb1 /ros 16,8;

/*Global defaults*/
__output    =   1;
_fcmptol    =   1E-10;
_verbose    =   1;

#include bgg_spec.g;
#include bgg_mod.src;
#include bgg_para.src;
#include pathspec.g;
#include debt.src;


nvar    = 9;
nvar2   = 4;
nshocks = 9;
nirf =5;// 200;//40;


yyirf1 = zeros(nirf, nvar*nshocks);
yyirf2 = zeros(nirf, nvar*nshocks);
yyirf3 = zeros(nirf, nvar*nshocks);

yyirf11 = zeros(nirf, nvar2*nshocks);
yyirf22 = zeros(nirf, nvar2*nshocks);
yyirf33 = zeros(nirf, nvar2*nshocks);



hpdprob     = 0.95;
block_size  = 0.8*(150*2500);
nburn=.2*(150*2500);

mhrun = "2";
 
/** parameter name **/
{para,para_names} = psel(miss(0,0),msel);
   #ifos2win
        lpath  = parapath $+ "\\mhrun" $+ mhrun;
        opath  = parapath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath  = parapath $+ "/mhrun" $+ mhrun;
        opath  = parapath $+ "/mhrun" $+ mhrun;
   #endif


chkdir = chk_dir(opath);

   #ifos2win
        ldraw  = lpath $+ "\\pa.dat"  ;
        odraws = opath $+ "\\pas.dat" ;
   #endif 
  
   #ifunix 
        ldraw  = lpath $+ "/pa.dat"  ;
        odraws = opath $+ "/pas.dat" ;
   #endif


/********************************************************
* Computes posterior mean and std and CI 
********************************************************/
#include p_parapmom_median.g;

para = drawmedian;

//para[13]=0.9; para[59]=0.9;
//para[59]=0.81;
//para[54]=5;
para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
//para3     = para[1:2]|para[5:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];

//para3     = para[1:2]|para[5]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
para3     = para[1:2]|para[4]|para[6:15]|para[18]|para[21]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
        impind  =   1;
        do until impind > nshocks;
            impact1  =   zeros(nshocks,1);
            impact2  =   zeros(nshocks,1);
            impact3  =   zeros(nshocks,1);
                

            impact1[impind]  =  1;
            impact2[impind]  =   1;
            impact3[impind]  =   1;
            
/*Wealth shock: 1% increase in wealth in 1960s*/
//            impact1[impind]  =   1/1.8023006 ;                
//            impact2[impind]  =   1/1.8023006 ;     
//           impact3[impind]  =    1/1.8023006 ;  

/*1% increase in wealth in 1970s*/

impact1[impind]  = 1/2.2011746 ;   
impact2[impind]  = 1/2.2011746 ;   
impact3[impind]  = 1/2.2011746 ;   

/* ONLY MU: 1% increase in wealth in 1970s*/


/*Shock to bank. cost: 1% increase in wealth in 1960s*/
       
//           impact1[impind]  =  1/0.016998916;
//            impact2[impind]  =   1/0.016998916;
//            impact3[impind]  =  1/0.016998916;

/*1% increase in wealth in 1970s*/

//impact1[impind]=1/0.018432813;
//impact2[impind]=1/0.018432813;
//impact3[impind]=1/0.018432813;

/*MP shock: 0.25% increase in ffr in 1960s*/
//       
//           impact1[impind]  =  0.25*1/0.78581696;
//            impact2[impind]  =   0.25*1/0.78581696;
//            impact3[impind]  =  0.25*1/0.78581696;  
// For the variables used in the estimation

            yyirf1[1:nirf,nvar*(impind-1)+1:nvar*impind]           =   dsgeirf(para1',msel,nirf,impact1);
            yyirf2[1:nirf,nvar*(impind-1)+1:nvar*impind]           =   dsgeirf(para2',msel,nirf,impact2);
            yyirf3[1:nirf,nvar*(impind-1)+1:nvar*impind]           =   dsgeirf(para3',msel,nirf,impact3);   

// For other variables. 

            yyirf11[1:nirf,nvar2*(impind-1)+1:nvar2*impind]           =   dsgeirf_other(para1',msel,nirf,impact1);
            yyirf22[1:nirf,nvar2*(impind-1)+1:nvar2*impind]           =   dsgeirf_other(para2',msel,nirf,impact2);
            yyirf33[1:nirf,nvar2*(impind-1)+1:nvar2*impind]           =   dsgeirf_other(para3',msel,nirf,impact3);   

//yyirf1[.,49];
//yyirf1[1,26]
        impind          =    impind+1;
        endo;

/** start log file **/
   #ifos2win
        outstr = resupath $+ "\\irf.log";
   #endif 
  
   #ifunix 
        outstr = resupath $+ "/irf.log";      
   #endif

output file = ^outstr reset;

 "Output--net worth";
 yyirf1[.,55]~yyirf2[.,55]~yyirf3[.,55];
 "=================================================";
  "Investment--net worth";
 yyirf1[.,56]~yyirf2[.,56]~yyirf3[.,56];
 "=================================================";
  "Net worth--net worth";
 yyirf1[.,57]~yyirf2[.,57]~yyirf3[.,57];
 "=================================================";
 
   "Hours--net worth";
 yyirf1[.,58]~yyirf2[.,58]~yyirf3[.,58];
 "=================================================";
    "Wages--net worth";
 yyirf1[.,59]~yyirf2[.,59]~yyirf3[.,59];
 "=================================================";
     "Inflation--net worth";
 yyirf1[.,60]~yyirf2[.,60]~yyirf3[.,60];
 "=================================================";
      "FFR--net worth";
 yyirf1[.,61]~yyirf2[.,61]~yyirf3[.,61];
 "=================================================";
       "Consumption--net worth";
 yyirf1[.,62]~yyirf2[.,62]~yyirf3[.,62];
 "=================================================";

        "Spread--net worth";
 yyirf1[.,63]~yyirf2[.,63]~yyirf3[.,63];
 "=================================================";
 



        "Debt--net worth";
 yyirf11[.,25]~yyirf22[.,25]~yyirf33[.,25];
 "=================================================";
         "Leverage--net worth";
 yyirf11[.,26]~yyirf22[.,26]~yyirf33[.,26];
 "=================================================";
          "Omega--net worth";
 yyirf11[.,27]~yyirf22[.,27]~yyirf33[.,27];
 "=================================================";
           "E_Omega--net worth";
 yyirf11[.,28]~yyirf22[.,28]~yyirf33[.,28];
 "=================================================";

 "==================================================";
  "Output--mu";
 yyirf1[.,19]~yyirf2[.,19]~yyirf3[.,19];
 "=================================================";
  "Investment--mu";
 yyirf1[.,20]~yyirf2[.,20]~yyirf3[.,20];
 "=================================================";
  "Net worth--mu";
 yyirf1[.,21]~yyirf2[.,21]~yyirf3[.,21];
 "=================================================";
 
  "Hours--mu";
 yyirf1[.,22]~yyirf2[.,22]~yyirf3[.,22];
 "=================================================";
    "Wages--mu";
 yyirf1[.,23]~yyirf2[.,23]~yyirf3[.,23];
 "=================================================";
     "Inflation--mu";
 yyirf1[.,24]~yyirf2[.,24]~yyirf3[.,24];
 "=================================================";
      "FFR--mu";
 yyirf1[.,25]~yyirf2[.,25]~yyirf3[.,25];
 "=================================================";
       "Consumption--mu";
 yyirf1[.,26]~yyirf2[.,26]~yyirf3[.,26];
 "=================================================";

        "Spread--mu";
 yyirf1[.,27]~yyirf2[.,27]~yyirf3[.,27];
 "=================================================";
 

        "Debt--mu";
 yyirf11[.,9]~yyirf22[.,9]~yyirf33[.,9];
 "=================================================";
         "Leverage--mu";
 yyirf11[.,10]~yyirf22[.,10]~yyirf33[.,10];
 "=================================================";
          "Omega--mu";
 yyirf11[.,11]~yyirf22[.,11]~yyirf33[.,11];
 "=================================================";
           "E_Omega--mu";
 yyirf11[.,12]~yyirf22[.,12]~yyirf33[.,12];
 "=================================================";
 "==================================================";
   "Output--MP";
 yyirf1[.,64]~yyirf2[.,64]~yyirf3[.,64];
 "=================================================";
  "Investment--MP";
 yyirf1[.,65]~yyirf2[.,65]~yyirf3[.,65];
 "=================================================";
  "Net worth--MP";
 yyirf1[.,66]~yyirf2[.,66]~yyirf3[.,66];
 "=================================================";
 
   "Hours--MP";
 yyirf1[.,67]~yyirf2[.,67]~yyirf3[.,67];
 "=================================================";
    "Wages--MP";
 yyirf1[.,68]~yyirf2[.,68]~yyirf3[.,68];
 "=================================================";
     "Inflation--MP";
 yyirf1[.,69]~yyirf2[.,69]~yyirf3[.,69];
 "=================================================";
      "FFR--MP";
 yyirf1[.,70]~yyirf2[.,70]~yyirf3[.,70];
 "=================================================";
       "Consumption--MP";
 yyirf1[.,71]~yyirf2[.,71]~yyirf3[.,71];
 "=================================================";
        "Spread--MP";
 yyirf1[.,72]~yyirf2[.,72]~yyirf3[.,72];
 "=================================================";
 
        "Debt--MP";
 yyirf11[.,29]~yyirf22[.,29]~yyirf33[.,29];
 "=================================================";
         "Leverage--MP";
 yyirf11[.,30]~yyirf22[.,30]~yyirf33[.,30];
 "=================================================";
          "Omega--MP";
 yyirf11[.,31]~yyirf22[.,31]~yyirf33[.,31];
 "=================================================";
           "E_Omega--MP";
 yyirf11[.,32]~yyirf22[.,32]~yyirf33[.,32];
 "=================================================";
 "==================================================";

/** close log file **/
output file = ^outstr off;

/******************************************************************************************/

proc(1) = dsgeirf(para,msel,nirf,imp);
local TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ,ssirf,yyirf,t,k34;

{TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}           = sysmat(para,msel);

ssirf       =   zeros(nirf,cols(ZZ));
yyirf       =   zeros(nirf,rows(ZZ));
/*"RR";RR;k34=keyw;
"imp";imp;k34=keyw;*/
ssirf[1,.]  =   (RR*imp)';
/*"ss";ssirf[1,.];k34=keyw;*/
yyirf[1,.]  = ssirf[1,.]*ZZ';
/*"irf";yyirf[1,.];k34=keyw;*/
t=2;
do until t>nirf;
    ssirf[t,.] = (TT*ssirf[t-1,.]')';
    yyirf[t,.] = ssirf[t,.]*ZZ';
/*ssirf[t,.];
"";
yyirf[t,.];
"";
k34=keyw;*/
    t = t+1;
endo;
//"1";yyirf;
eofirf:
/*make the irf of the variables in growth rates cumulative to get the levels*/
yyirf[.,1] = cumsumc(yyirf[.,1]);
yyirf[.,2] = cumsumc(yyirf[.,2]);
yyirf[.,3] = cumsumc(yyirf[.,3]);
yyirf[.,5] = cumsumc(yyirf[.,5]);
yyirf[.,8] = cumsumc(yyirf[.,8]);
//"2";yyirf;k34=keyw;
retp(yyirf);
endp;



/******************************/
proc(1) = dsgeirf_other(para,msel,nirf,imp);
local TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ,ssirf,yyirf,t,k34;

{TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}           = sysmat_other(para,msel);

ssirf       =   zeros(nirf,cols(ZZ));
yyirf       =   zeros(nirf,rows(ZZ));
/*"RR";RR;k34=keyw;
"imp";imp;k34=keyw;*/
ssirf[1,.]  =   (RR*imp)';
/*"ss";ssirf[1,.];k34=keyw;*/
yyirf[1,.]  = ssirf[1,.]*ZZ';
/*"irf";yyirf[1,.];k34=keyw;*/
t=2;
do until t>nirf;
    ssirf[t,.] = (TT*ssirf[t-1,.]')';
    yyirf[t,.] = ssirf[t,.]*ZZ';
/*ssirf[t,.];
"";
yyirf[t,.];
"";
k34=keyw;*/
    t = t+1;
endo;
//"1";yyirf;
eofirf:
/*make the irf of the variables in growth rates cumulative to get the levels*/
yyirf[.,1] = cumsumc(yyirf[.,1]);

//"2";yyirf;k34=keyw;
retp(yyirf);
endp;
