new;
closeall;
library pgraph, user;
cls;
outwidth 256;

/*format /mat /on /mb1/ ros 16,8;*/

/*Global defaults*/
__output = 1;
_fcmptol = 1E-10;
_verbose = 1;

/** The following lines are model specific**/

nvar        =   9;
nshocks     =   9;
Tsimtotal   =  209+1000;
Tsimburn    =  1000;//200;
nsim        =  10;//20;

#include bgg_spec.g;
#include bgg_mod.src;
#include bgg_para.src;
#include pathspec.g;



/***************************************
load parameters draws from MH output
****************************************/
rndseed 1234;
//rndseed 234;
//rndseed 255;

mhrun       =   "2";
nblock      =   10000;//10000;  /*block size*/
nuse        =   1000;//1000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/** initialize output files **/
   #ifos2win
        oratioinsfin1      	= opath $+ "\\ratioinsfin_hp1.dat";     
        oratioinsfin2      	= opath $+ "\\ratioinsfin_hp2.dat";     
        oratioinsnfin1      	= opath $+ "\\ratioinsnfin_hp1.dat";     
        oratioinsnfin2      	= opath $+ "\\ratioinsnfin_hp2.dat";     
        oratiofinfin1      	= opath $+ "\\ratiofinfin_hp1.dat";     
        oratiofinfin2      	= opath $+ "\\ratiofinfin_hp2.dat";     
        oratiompfin1      	= opath $+ "\\ratiompfin_hp1.dat";     
        oratiompfin2      	= opath $+ "\\ratiofmpfin_hp2.dat";    
        oratiopi1      		= opath $+ "\\ratiopi_hp1.dat";     
        oratiopi2      		= opath $+ "\\ratiopi_hp2.dat";    
        oratioy1      		= opath $+ "\\ratioy_hp1.dat";     
        oratioy2      		= opath $+ "\\ratioy_hp2.dat";    



   #endif 
  
   #ifunix 
        oratioinsfin1      	= opath $+ "/ratioinsfin_hp1.dat";     
        oratioinsfin2      	= opath $+ "/ratioinsfin_hp2.dat";     
        oratioinsnfin1      	= opath $+ "/ratioinsnfin_hp1.dat";     
        oratioinsnfin2      	= opath $+ "/ratioinsnfin_hp2.dat";   
        oratiofinfin1      	= opath $+ "/ratiofinfin_hp1.dat";     
        oratiofinfin2      	= opath $+ "/ratiofinfin_hp2.dat";   
        oratiompfin1      	= opath $+ "/ratiompfin_hp1.dat";     
        oratiompfin2      	= opath $+ "/ratiompfin_hp2.dat";   
        oratiopi1      		= opath $+ "/ratiopi_hp1.dat";     
        oratiopi2      		= opath $+ "/ratiopi_hp2.dat";    
        oratioy1      		= opath $+ "/ratioy_hp1.dat";     
        oratioy2      		= opath $+ "/ratioy_hp2.dat";    



   #endif
   

 


  
create fhratioinsfin1  = ^oratioinsfin1  with SPEC, nvar, 8;
create fhratioinsfin2  = ^oratioinsfin2  with SPEC, nvar, 8;

/************************************************************************************************************************/
/* COUNTERFACTUAL 1: CHANGES IN INSTITUTIONS AND FINANCIAL SHOCKS  */

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread1";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:30]|para[33]|para[37]|para[39]|para[42]|para[45]|para[49]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[5]|para[6:15]|para[18]|para[21]|para[22:29]|para[31]|para[34]|para[38]|para[40]|para[43]|para[46]|para[50]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            

                
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          

        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratioinsfin1,aratio1);
    wr = writer(fhratioinsfin2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratioinsfin1, fhratioinsfin2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratioinsfin1 =  ^oratioinsfin1 for read;
nburn=1;
drawrow = readr(fhratioinsfin1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioinsfin1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioinsfin1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioinsfin1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioinsfin1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioinsfin1,nburn);
   drawblock = readr(fhratioinsfin1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioinsfin1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioinsfin1);

   endo;

   if _verbose;".";;pause(1e-20);endif;

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN INSTITUTIONS AND FINANCIAL SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratioinsfin2 =  ^oratioinsfin2 for read;
nburn=1;
drawrow = readr(fhratioinsfin2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioinsfin2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioinsfin2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioinsfin2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioinsfin2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioinsfin2,nburn);
   drawblock = readr(fhratioinsfin2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioinsfin2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioinsfin2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;


closeall  fhpara, fhratioinsfin1, fhratioinsfin2;


/************************************************************************************************************
*************************************************************************************************************
**************************************************************************************************************/

/************************************************************************************************************************/
/* COUNTERFACTUAL 4: CHANGES IN INSTITUTIONS AND NON FIN SHOCKS  */
create fhratioinsnfin1  = ^oratioinsnfin1 with SPEC, nvar, 8;
create fhratioinsnfin2  = ^oratioinsnfin2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
			
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[36]|para[40]|para[43]|para[46]|para[48]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[5]|para[6:15]|para[18]|para[21]|para[22:29]|para[32]|para[35]|para[37]|para[41]|para[44]|para[47]|para[49]|para[53]|para[54:62]|para[65]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratioinsnfin1,aratio1);
    wr = writer(fhratioinsnfin2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratioinsnfin1, fhratioinsnfin2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratioinsnfin1 =  ^oratioinsnfin1 for read;
nburn=1;
drawrow = readr(fhratioinsnfin1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioinsnfin1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioinsnfin1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioinsnfin1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioinsnfin1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioinsnfin1,nburn);
   drawblock = readr(fhratioinsnfin1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioinsnfin1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioinsnfin1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN INSTITUTIONS AND NON FIN SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratioinsnfin2 =  ^oratioinsnfin2 for read;
nburn=1;
drawrow = readr(fhratioinsnfin2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioinsnfin2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioinsnfin2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioinsnfin2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioinsnfin2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioinsnfin2,nburn);
   drawblock = readr(fhratioinsnfin2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioinsnfin2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioinsnfin2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratioinsnfin1, fhratioinsnfin2;

/*******************************************************************************************
*******************************************************************************************
******************************************************************************************/
/************************************************************************************************************************/
/* COUNTERFACTUAL 5: CHANGES IN FIN INSTITUTIONS AND FIN SHOCKS   */

create fhratiofinfin1  = ^oratiofinfin1 with SPEC, nvar, 8;
create fhratiofinfin2  = ^oratiofinfin2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
		
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[4]|para[6:15]|para[16]|para[19]|para[22:30]|para[33]|para[37]|para[39]|para[42]|para[45]|para[49]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[5]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[38]|para[40]|para[43]|para[46]|para[50]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiofinfin1,aratio1);
    wr = writer(fhratiofinfin2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiofinfin1, fhratiofinfin2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiofinfin1 =  ^oratiofinfin1 for read;
nburn=1;
drawrow = readr(fhratiofinfin1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiofinfin1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiofinfin1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiofinfin1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiofinfin1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiofinfin1,nburn);
   drawblock = readr(fhratiofinfin1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiofinfin1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiofinfin1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN FIN INSTITUTIONS AND FIN SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiofinfin2 =  ^oratiofinfin2 for read;
nburn=1;
drawrow = readr(fhratiofinfin2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiofinfin2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiofinfin2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiofinfin2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiofinfin2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiofinfin2,nburn);
   drawblock = readr(fhratiofinfin2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiofinfin2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiofinfin2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratiofinfin1, fhratiofinfin2;

/********************************************************************************************
***********************************************************************************************
************************************************************************************************/


/* COUNTERFACTUAL 5: CHANGES IN FIN INSTITUTIONS AND FIN SHOCKS   */

create fhratiompfin1  = ^oratiompfin1 with SPEC, nvar, 8;
create fhratiompfin2  = ^oratiompfin2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
		
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[3]|para[6:15]|para[17]|para[20]|para[22:30]|para[33]|para[37]|para[39]|para[42]|para[45]|para[49]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[18]|para[21]|para[22:29]|para[31]|para[34]|para[38]|para[40]|para[43]|para[46]|para[50]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiompfin1,aratio1);
    wr = writer(fhratiompfin2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiompfin1, fhratiompfin2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiompfin1 =  ^oratiompfin1 for read;
nburn=1;
drawrow = readr(fhratiompfin1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiompfin1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiompfin1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiompfin1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiompfin1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiompfin1,nburn);
   drawblock = readr(fhratiompfin1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiompfin1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiompfin1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN MP AND FIN SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiompfin2 =  ^oratiompfin2 for read;
nburn=1;
drawrow = readr(fhratiompfin2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiompfin2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiompfin2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiompfin2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiompfin2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiompfin2,nburn);
   drawblock = readr(fhratiompfin2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiompfin2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiompfin2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratiompfin1, fhratiompfin2;

/********************************************************************************************
***********************************************************************************************
************************************************************************************************/



/********************************************************************************************
***********************************************************************************************
************************************************************************************************/


/* COUNTERFACTUAL 5: CHANGES IN MP RESPONSE TO INFLATION   */

create fhratiopi1  = ^oratiopi1 with SPEC, nvar, 8;
create fhratiopi2  = ^oratiopi2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
		
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:3]|para[6:15]|para[17]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[18]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiopi1,aratio1);
    wr = writer(fhratiopi2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiopi1, fhratiopi2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiopi1 =  ^oratiopi1 for read;
nburn=1;
drawrow = readr(fhratiopi1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiopi1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiopi1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiopi1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiopi1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiopi1,nburn);
   drawblock = readr(fhratiopi1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiopi1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiopi1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN THE RESPONSE TO INFLATION";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiopi2 =  ^oratiopi2 for read;
nburn=1;
drawrow = readr(fhratiopi2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiopi2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiopi2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiopi2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiopi2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiopi2,nburn);
   drawblock = readr(fhratiopi2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiopi2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiopi2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratiopi1, fhratiopi2;

/********************************************************************************************
***********************************************************************************************
************************************************************************************************/




/********************************************************************************************
***********************************************************************************************
************************************************************************************************/


/* COUNTERFACTUAL 5: CHANGES IN MP RESPONSE TO OUTPUT GROWTH   */

create fhratioy1  = ^oratioy1 with SPEC, nvar, 8;
create fhratioy2  = ^oratioy2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
		
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:3]|para[6:16]|para[20]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[17]|para[21]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratioy1,aratio1);
    wr = writer(fhratioy2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratioy1, fhratioy2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratioy1 =  ^oratioy1 for read;
nburn=1;
drawrow = readr(fhratioy1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioy1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioy1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioy1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioy1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioy1,nburn);
   drawblock = readr(fhratioy1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioy1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioy1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN THE RESPONSE TO OUTPUT GROWTH";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratioy2 =  ^oratioy2 for read;
nburn=1;
drawrow = readr(fhratioy2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioy2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioy2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioy2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioy2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioy2,nburn);
   drawblock = readr(fhratioy2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioy2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioy2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratioy1, fhratioy2;

/********************************************************************************************
***********************************************************************************************
************************************************************************************************/

/*********************************************/
/*********************************************/
proc(3) = dsgesim_2(para1,pmsel,Tsimburn,Tsimtotal);
local TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ, 
      HHchol,QQchol,neps,nstate,ny, 
      yt,st,epst,t,
      TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2,HHchol2,QQchol2,
      ssteady1,ssteady2;
     
/*System matrices for the state-space representation*/
     
    {TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}            = sysmat_3(para1, msel);
    

ssteady1  =  sysmat_ssteady_sub(para1,msel);
neps    =   cols(QQ);
nstate  =   cols(TT);
ny      =   rows(ZZ);

QQchol  =   chol(QQ)';
HHchol  =   cholpsd(HH);  /**Recall that HH=zeros since we are not considering measurement errors**/

/*Simulating the DSGE model*/
 yT     =   zeros(Tsimtotal-Tsimburn,ny);
 st     =   ssteady1[1:46];/*zeros(nstate,1);*/
 
 t  =   1;
 do until t > Tsimtotal-Tsimburn;
        epst    =   QQchol*rndn(neps,1);
        st      =   JJ + TT*st + RR*epst;
        /*yT[t,.] =   DD' + (ZZ*(st-JJ))' + (HHchol*rndn(ny,1))';*/
        yT[t,.] =    (ZZ*st)' + (HHchol*rndn(ny,1))';
    t       =   t+1;
 endo;
 
yT = yT[1:Tsimtotal-Tsimburn,.];


 retp(yT, RC, RC);
 endp;

/********************************************************************/
proc(1) = hpdint(draws,percent);

local ndraws,drawdim,hpdband,nwidth,i,drawcoli,bup,minwidth,newwidth,j;

drawdim = cols(draws);
ndraws  = rows(draws);
hpdband = zeros(2,drawdim);
nwidth  = int(percent*ndraws);

i = 1;
do until i> drawdim;
    drawcoli = draws[.,i];
    /*sort response for period i, element 1 is max*/
     drawcoli   = rev(sortc(drawcoli,1));
     bup        = 1;
     minwidth   = drawcoli[1] - drawcoli[nwidth];
     j = 2;
     do until j > (ndraws-nwidth+1);
        newwidth    =  drawcoli[j] - drawcoli[j+nwidth-1];
        if newwidth < minwidth;
            bup = j;
            minwidth    = newwidth;
        endif;
        j = j+1;
    endo;
    hpdband[2,i]    = drawcoli[bup];
    hpdband[1,i]    = drawcoli[bup+nwidth-1];
    i = i+1;
endo;
retp(hpdband);
endp;


/*********************************************/
proc(3) = dsgesim_3(para1,pmsel,Tsimburn,Tsimtotal);
local TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ, 
      HHchol,QQchol,neps,nstate,ny, 
      yt,st,epst,t,
      TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2,HHchol2,QQchol2,
      ssteady1,ssteady2;
     
/*System matrices for the state-space representation*/
     
    {TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}            = sysmat_3(para1, msel);
    

ssteady1  =  sysmat_ssteady_sub(para1,msel);
neps    =   cols(QQ);
nstate  =   cols(TT);
ny      =   rows(ZZ);

QQchol  =   chol(QQ)';
HHchol  =   cholpsd(HH);  /**Recall that HH=zeros since we are not considering measurement errors**/

/*Simulating the DSGE model*/
 yT     =   zeros(Tsimtotal-Tsimburn,ny);
 st     =   ssteady1;/*zeros(nstate,1);*/
 
 t  =   1;
 do until t > Tsimtotal-Tsimburn;
        epst    =   QQchol*rndn(neps,1);
        st      =   JJ + TT*st + RR*epst;
        /*yT[t,.] =   DD' + (ZZ*(st-JJ))' + (HHchol*rndn(ny,1))';*/
        yT[t,.] =    (ZZ*st)' + (HHchol*rndn(ny,1))';
    t       =   t+1;
 endo;
 
yT = yT[1:Tsimtotal-Tsimburn,.];


 retp(yT, RC, RC);
 endp;




/*********************************************************/
proc(1) = hpfilter(y,w);

local t,a,b,c,d,m,i,j,shp;

    t       = rows(y);
    a       = 6*w+1;
    b       = -4*w;
    c       = w;
    d 	    = c~b~a;

d       = ones(t,1)*d;

d[1,1]=0;
d[2,1]=0;
d[1,2]=0;

d[2,2] = -2*w;
d[t,2] = -2*w;

d[1,3] = 1+w;
d[t,3] = 1+w;

d[2,3]=5*w+1;
d[t-1,3]=5*w+1;

@ The Smoothed Series @

shp = bandsolpd(eye(t),d)*y;

retp(shp);
endp;







/********************************************************************
**      System matrices for state-space representation with DDcoint
**
**      {TT,QQ,RR,HH,DD,ZZ,VV,Z_t,RC,code_nsp}=sysmat(para,msel);                
********************************************************************/
proc (9) = sysmat_3(para,msel);
    local T1, TC, T0, TETA, RC, TT, QQ, RR, HH, ZZ, DD,VV, ny, nz, nep, nstate, retcode,
          eq_gva, eq_inv, eq_lev, eq_h, eq_pi, eq_ffr, eq_ls,v_w,y_star,w_star,log_ystar,log_wstar,
          v_y, v_i, v_rn, v_nw, v_h, v_pi, v_z,v_chi,log_chistar,k34,v_debtlag,v_Erk,log_cstar,
log_istar,k_star,log_kstar,
log_nstar,e_z, e_zeta, e_gam, e_r, e_mark, e_theta,e_mu,d_star,nw_star,eq_debt,v_wlag,rk_Star,eq_k,v_k,v_klag,
          v_ylag, v_ilag, n_lag,v_nwlag,eq_nw,e_b,sigma_b,JJ,ssteady_partial,eq_c,v_c,v_clag,c_star,i_star,n_star,v_q,
          lnratio_star,ratio_star,h_star,log_hstar,pi_star,beta,upsilon_z,sigma_z,sigma_zeta,sigma_gam,sigma_mu,sigma_r,sigma_mark,sigma_theta,
          log_pi,log_sc_z,log_rn,sc_z_star,steady,valid_cy,valid_cy_1,valid_cy_2,rn_star,eq_d,eq_xp,v_rk,v_rlag,v_d,v_r,r_star,v_dlag, log_rk,
          e_g,sg,v_xp,xp_star;





/**Solve DSGE model**/
{T1,TC,T0,TETA,RC,retcode} = dsgesolv(para,msel);
/*print "T1";
T1;
print "T0";s
T0;
*/
/**Observation indices**/
if (msel==11);
    eq_gva  =   1;
    eq_inv  =   2;
    eq_nw   =   3;
    eq_h    =   4;
    eq_ls    =  5;
    eq_pi   =   6;
    eq_ffr  =   7;
    eq_c    = 8;
    eq_xp   =   9;
    ny      =   9;
endif;

/**variable indices**/
v_y     =   1;
v_i     =   3;
v_rn    =   8;
v_h     =   10;
v_w     =   11;
v_pi    =   13;
v_nw    =   15;
v_z     =   20;
v_d     =   4;
v_c     =   2;
v_Erk   =   37;   
v_r     =   7;

/**Shock indices**/
if (msel==11) or (msel==31);
    e_z      = 1;
    e_zeta   = 2;
    e_mu   = 3;
    e_mark   = 4;
    e_theta  = 5;
    e_b      = 6;
    e_gam    = 7;
    e_r      = 8;
    e_g      = 9;
endif;

/**names to parameters**/
{steady,valid_cy,valid_cy_1,valid_cy_2}=getpara(para,msel);

   
pi_star         =   steady[5];    
beta            =   steady[6];
upsilon_z       =   steady[22];
log_hstar       =   steady[8];
y_star          =   steady[67];
w_star          =   steady[68];
rn_star         =   steady[50];
rk_star         =   steady[52];
r_star          =   steady[51];
xp_star         =   steady[46];

c_star          =   steady[71]*y_star;
i_star          =   steady[61]*steady[64];
n_star          =   steady[65];
    

log_sc_z        =   upsilon_z;
log_rn          =   ln(rn_star);
log_pi          =   ln(pi_star);
log_ystar	    =   ln(y_star);
log_wstar       =   ln(w_star);
log_cstar       =   ln(c_star);
log_istar       =   ln(i_star);
log_nstar       =   ln(n_star);
log_rk          =   ln(rk_star);


sigma_z         =   steady[24];
sigma_zeta      =   steady[25];
sigma_mu        =   steady[26];
sigma_mark      =   steady[27];
sigma_theta     =   steady[28];
sigma_b         =   steady[29];
sigma_gam       =   steady[30];
sigma_r         =   steady[31];
sg              =   steady[41];
/*************************************************
**       Transition equations with augmentation
**
**       z(t) = T1*z(t-1) + T0*e(t)
**       x(t) = [z(t)',...]'
**
**       x(t) = TT*x(t-1) + RR*e(t)
**       e(t) ~ iid N(0,QQ)
*************************************************/
nz  = cols(T1);
nep = cols(T0);


TT = zeros(nz,nz);

TT[1:nz,1:nz]       = T1;

QQ                  = zeros(nep,nep);
QQ[e_z,e_z]         = sigma_z^2;
QQ[e_zeta,e_zeta]   = sigma_zeta^2;
QQ[e_mu,e_mu]       = sigma_mu^2;
QQ[e_mark,e_mark]   = sigma_mark^2;
QQ[e_theta,e_theta] = sigma_theta^2;
QQ[e_r,e_r]         = sigma_r^2;
QQ[e_b,e_b]         = sigma_b^2;
QQ[e_gam,e_gam]     = sigma_gam^2;
QQ[e_g,e_g]         = sg^2;

RR = T0;

ssteady_partial     = sysmat_ssteady_sub(para,msel);
JJ = (eye(cols(TT)) - TT) *(ssteady_partial[1:rows(ssteady_partial)-6]);
/*************************************************
** Measurement equations
**
*************************************************/
nstate = cols(TT);

DD = zeros(ny,1);    

DD[eq_gva,1]    = log_sc_z+log_ystar;
DD[eq_inv,1]    = log_sc_z+log_istar;
DD[eq_nw,1]     = log_sc_z+log_nstar;
DD[eq_h,1]      = log_hstar;
DD[eq_ls,1]     = log_sc_z+log_wstar;
DD[eq_pi,1]     = log_pi;//0;//
DD[eq_ffr,1]    =  log_rn; //log_rk - log_rn;   //  
DD[eq_c,1]   = log_sc_z+log_cstar;//log_sc_z+log_kstar;//
DD[eq_xp, 1]  = ln(1+xp_star);//log_rk - log_rn;

ZZ = zeros(ny,nstate);

ZZ[eq_gva,v_y]      =  1;
ZZ[eq_gva,v_z]      =  1;

ZZ[eq_inv,v_i]      =  1;
ZZ[eq_inv,v_z]      =  1;

ZZ[eq_nw,v_nw]      =  1;
ZZ[eq_nw,v_z]       =  1;

ZZ[eq_h, v_h]      = 1;

// wage growth
ZZ[eq_ls,v_w]        =  1;
ZZ[eq_ls,v_z]        =  1;


ZZ[eq_pi,v_pi]      =  1;

ZZ[eq_ffr,v_rn]     =  1;

ZZ[eq_c,v_c]      =  1;
ZZ[eq_c,v_z]       =  1;

ZZ[eq_xp,v_Erk]    = rk_star/(1+xp_star);  
ZZ[eq_xp,v_r]     =  -r_star/(1+xp_star);  

HH = zeros(ny,ny);  /** w/o measurement error **/

/*print "DD";
DD;
print "ZZ";
ZZ';*/
VV = zeros(nep,ny);

retp(TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ);
endp;






