new;
closeall;
library pgraph, user;
cls;
outwidth 256;

/*format /mat /on /mb1/ ros 16,8;*/

/*Global defaults*/
__output = 1;
_fcmptol = 1E-10;
_verbose = 1;

/** The following lines are model specific**/

nvar        =   9;
nshocks     =   9;
Tsimtotal   =  209+1000;
Tsimburn    =  1000;//200;
nsim        =  10;//20;

#include bgg_spec.g;
#include bgg_mod.src;
#include bgg_para.src;
#include pathspec.g;



/***************************************
load parameters draws from MH output
****************************************/
rndseed 1234;
//rndseed 234;
//rndseed 255;

mhrun       =   "2";
nblock      =   10000;//10000;  /*block size*/
nuse        =   1000;//1000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/** initialize output files **/
   #ifos2win
        oratiomu1      = opath $+ "\\ratiomu_hp1.dat";     
        oratiomu2      = opath $+ "\\ratiomu_hp2.dat";     
        oratioxp1      = opath $+ "\\ratioxp1.dat";     
        oratioxp2      = opath $+ "\\ratioxp2.dat";     
        oratioifin1      = opath $+ "\\ratioifin1.dat";     
        oratioifin2      = opath $+ "\\ratioifin2.dat";     
        oratiomp1      = opath $+ "\\ratiomp1_hp.dat";     
        oratiomp2      = opath $+ "\\ratiomp2_hp.dat";     
        oratioins1      = opath $+ "\\ratioins1_hp.dat";     
        oratioins2      = opath $+ "\\ratioins2_hp.dat";     
        oratiofin1      = opath $+ "\\ratiofin1_hp.dat";     
        oratiofin2      = opath $+ "\\ratiofin2_hp.dat";     
        oratioshock1      = opath $+ "\\ratioshock1_hp.dat";     
        oratioshock2      = opath $+ "\\ratioshock2_hp.dat";     
        oratioall1      = opath $+ "\\ratioall1_hp.dat";     
        oratioall2      = opath $+ "\\ratioall2_hp.dat";     
        oratiototal1      = opath $+ "\\ratiototal1_hp.dat";     
        oratiototal2      = opath $+ "\\ratiototal2_hp.dat";  
   #endif 
  
   #ifunix 
        oratiomu1      = opath $+ "/ratiomu_hp1.dat";     
        oratiomu2      = opath $+ "/ratiomu_hp2.dat";     
        oratioxp1      = opath $+ "/ratioxp1.dat";     
        oratioxp2      = opath $+ "/ratioxp2.dat";     
        oratioifin1      = opath $+ "/ratioifin1.dat";     
        oratioifin2      = opath $+ "/ratioifin2.dat";     
        oratiomp1      = opath $+ "/ratiomp1_hp.dat";     
        oratiomp2      = opath $+ "/ratiomp2_hp.dat";     
        oratioins1      = opath $+ "/ratioins1_hp.dat";     
        oratioins2      = opath $+ "/ratioins2_hp.dat";     
        oratiofin1      = opath $+ "/ratiofin1_hp.dat";     
        oratiofin2      = opath $+ "/ratiofin2_hp.dat";     
        oratioshock1      = opath $+ "/ratioshock1_hp.dat";     
        oratioshock2      = opath $+ "/ratioshock2_hp.dat";     
        oratioall1      = opath $+ "/ratioall1_hp.dat";     
        oratioall2      = opath $+ "/ratioall2_hp.dat";     
        oratiototal1      = opath $+ "/ratiototal1_hp.dat";     
        oratiototal2      = opath $+ "/ratiototal2_hp.dat";  
   #endif
   

 


  
create fhratiomu1  = ^oratiomu1 with SPEC, nvar, 8;
create fhratiomu2  = ^oratiomu2 with SPEC, nvar, 8;

/************************************************************************************************************************/
/* COUNTERFACTUAL 1: CHANGES IN THE LEVEL OF FINANCIAL RIGIDITIES  */

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread1";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[4]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[5:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            

                
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          

        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiomu1,aratio1);
    wr = writer(fhratiomu2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiomu1, fhratiomu2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiomu1 =  ^oratiomu1 for read;
nburn=1;
drawrow = readr(fhratiomu1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiomu1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiomu1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiomu1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiomu1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiomu1,nburn);
   drawblock = readr(fhratiomu1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiomu1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiomu1);

   endo;

   if _verbose;".";;pause(1e-20);endif;

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN THE LEVEL OF FINANCIAL RIGIDITY";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiomu2 =  ^oratiomu2 for read;
nburn=1;
drawrow = readr(fhratiomu2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiomu2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiomu2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiomu2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiomu2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiomu2,nburn);
   drawblock = readr(fhratiomu2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiomu2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiomu2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;


closeall  fhpara, fhratiomu1, fhratiomu2;


/************************************************************************************************************
*************************************************************************************************************
**************************************************************************************************************/

/************************************************************************************************************************/
/* COUNTERFACTUAL 4: CHANGES IN MONETARY POLICY  */
create fhratiomp1  = ^oratiomp1 with SPEC, nvar, 8;
create fhratiomp2  = ^oratiomp2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
			
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:3]|para[6:15]|para[17]|para[20]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[18]|para[21]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiomp1,aratio1);
    wr = writer(fhratiomp2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiomp1, fhratiomp2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiomp1 =  ^oratiomp1 for read;
nburn=1;
drawrow = readr(fhratiomp1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiomp1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiomp1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiomp1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiomp1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiomp1,nburn);
   drawblock = readr(fhratiomp1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiomp1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiomp1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN MONETARY POLICY";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiomp2 =  ^oratiomp2 for read;
nburn=1;
drawrow = readr(fhratiomp2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiomp2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiomp2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiomp2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiomp2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiomp2,nburn);
   drawblock = readr(fhratiomp2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiomp2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiomp2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratiomp1, fhratiomp2;

/*******************************************************************************************
*******************************************************************************************
******************************************************************************************/
/************************************************************************************************************************/
/* COUNTERFACTUAL 5: CHANGES IN INSTITUTIONS  */

create fhratioins1  = ^oratioins1 with SPEC, nvar, 8;
create fhratioins2  = ^oratioins2 with SPEC, nvar, 8;

//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread2";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
		
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[5:15]|para[18]|para[21]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratioins1,aratio1);
    wr = writer(fhratioins2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratioins1, fhratioins2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratioins1 =  ^oratioins1 for read;
nburn=1;
drawrow = readr(fhratioins1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioins1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioins1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioins1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioins1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioins1,nburn);
   drawblock = readr(fhratioins1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioins1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioins1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN INSTITUTIONS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratioins2 =  ^oratioins2 for read;
nburn=1;
drawrow = readr(fhratioins2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioins2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioins2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioins2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioins2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioins2,nburn);
   drawblock = readr(fhratioins2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioins2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioins2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratioins1, fhratioins2;

/********************************************************************************************
***********************************************************************************************
************************************************************************************************/


/************************************************************************************************************************/
/* COUNTERFACTUAL 6: CHANGES IN FINANCIAL SHOCKS  */
create fhratiofin1  = ^oratiofin1 with SPEC, nvar, 8;
create fhratiofin2  = ^oratiofin2 with SPEC, nvar, 8;
//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);


/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);

    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';

            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[37]|para[39]|para[42]|para[45]|para[49]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[38]|para[40]|para[43]|para[46]|para[50]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);


            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;

            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiofin1,aratio1);
    wr = writer(fhratiofin2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiofin1, fhratiofin2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiofin1 =  ^oratiofin1 for read;
nburn=1;
drawrow = readr(fhratiofin1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiofin1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiofin1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiofin1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiofin1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiofin1,nburn);
   drawblock = readr(fhratiofin1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiofin1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiofin1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN FINANCIAL SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiofin2 =  ^oratiofin2 for read;
nburn=1;
drawrow = readr(fhratiofin2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiofin2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiofin2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiofin2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiofin2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiofin2,nburn);
   drawblock = readr(fhratiofin2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiofin2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiofin2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratiofin1, fhratiofin2;

/***************************************************************************************
*****************************************8
*********************************************************************************/


/************************************************************************************************************************/
/* COUNTERFACTUAL 8: CHANGES IN REMAINING SHOCKS  */
create fhratioshock1  = ^oratioshock1 with SPEC, nvar, 8;
create fhratioshock2  = ^oratioshock2 with SPEC, nvar, 8;


//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);

    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';

            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:3]|para[6:16]|para[19]|para[22:29]|para[31]|para[34]|para[36]|para[40]|para[43]|para[46]|para[48]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[32]|para[35]|para[37]|para[41]|para[44]|para[47]|para[49]|para[53]|para[54:62]|para[65]|para[66:69]|para[70:72];
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratioshock1,aratio1);
    wr = writer(fhratioshock2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratioshock1, fhratioshock2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratioshock1 =  ^oratioshock1 for read;
nburn=1;
drawrow = readr(fhratioshock1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioshock1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioshock1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioshock1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioshock1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioshock1,nburn);
   drawblock = readr(fhratioshock1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioshock1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioshock1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN REMAINING SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratioshock2 =  ^oratioshock2 for read;
nburn=1;
drawrow = readr(fhratioshock2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioshock2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioshock2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioshock2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioshock2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioshock2,nburn);
   drawblock = readr(fhratioshock2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioshock2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioshock2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratioshock1, fhratioshock2;

/************************************************************************************************************************/
/************************************************************************************************************************/
/************************************************************************************************************************/

/************************************************************************************************************************/
/* COUNTERFACTUAL 8: CHANGES IN ALL SHOCKS  */
create fhratioall1  = ^oratioall1 with SPEC, nvar, 8;
create fhratioall2  = ^oratioall2 with SPEC, nvar, 8;


//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);

    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';

			
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:3]|para[6:16]|para[19]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            
            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53]|para[54:62]|para[65]|para[66:69]|para[70:72];
            
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;



            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratioall1,aratio1);
    wr = writer(fhratioall2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratioall1, fhratioall2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratioall1 =  ^oratioall1 for read;
nburn=1;
drawrow = readr(fhratioall1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioall1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioall1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioall1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioall1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioall1,nburn);
   drawblock = readr(fhratioall1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioall1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioall1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN ALL SHOCKS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratioall2 =  ^oratioall2 for read;
nburn=1;
drawrow = readr(fhratioall2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratioall2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratioall2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratioall2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratioall2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratioall2,nburn);
   drawblock = readr(fhratioall2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratioall2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratioall2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratioall1, fhratioall2;



/************************************************************************************************************************/
/* COUNTERFACTUAL 9: CHANGES IN ALL RELEVANT PARAMETERS  */
create fhratiototal1  = ^oratiototal1 with SPEC, nvar, 8;
create fhratiototal2  = ^oratiototal2 with SPEC, nvar, 8;


//nblock      =   10000;  /*block size*/
//nuse        =   5000;//1000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif


chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif

open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/*Initialization*/
eofloop      = 0;
loopct       = 1;

/*if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
*/
do until eofloop;
  /*  if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;
*/
    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);
//"nread1";nread;
    if ismiss(parasim) == 0;

        aratio1      =   zeros(nread,nvar);
        aratio2      =   zeros(nread,nvar);

        j           =   1;
        
        do until j > nread;
            para        =   parasim[j,.]';
	
            
            para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
            para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];

            para3     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
            para4     = para[1:2]|para[5:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];
            
            
            jj = 1;

            st_1        =   zeros(nsim,nvar); 
            st_2        =   zeros(nsim,nvar);
            st_3        =   zeros(nsim,nvar);
            st_4        =   zeros(nsim,nvar);
            rt_1        =   zeros(nsim,nvar);
            rt_2        =   zeros(nsim,nvar);

            do until jj > nsim;  
            {y_1, RC1, RC2} =   dsgesim_2(para1, msel, Tsimburn, tsimtotal);
            {y_2, RC1, RC2} =   dsgesim_2(para2, msel, Tsimburn, tsimtotal);
            {y_3, RC1, RC2} =   dsgesim_2(para3, msel, Tsimburn, tsimtotal);
            {y_4, RC1, RC2} =   dsgesim_2(para4, msel, Tsimburn, tsimtotal);

            jjj=1;
            do until jjj  >  nvar;
               y_1[.,jjj] = y_1[.,jjj]-hpfilter(Y_1[.,jjj],1600);
               y_2[.,jjj] = y_2[.,jjj]-hpfilter(Y_2[.,jjj],1600);
               y_3[.,jjj] = y_3[.,jjj]-hpfilter(Y_3[.,jjj],1600);
               y_4[.,jjj] = y_4[.,jjj]-hpfilter(Y_4[.,jjj],1600);
            jjj = jjj+1;
            endo;


            st_1[jj,.]  = stdc(y_1)';           
            st_2[jj,.]  = stdc(y_2)';
            st_3[jj,.]  = stdc(y_3)';
            st_4[jj,.]  = stdc(y_4)';

            rt_1[jj,.]  = stdc(y_2)'./stdc(y_1)';
            rt_2[jj,.]  = stdc(y_4)'./stdc(y_3)';

            jj = jj+1;
            endo;


            ratio_1       =   zeros(1,nvar);
            ratio_2       =   zeros(1,nvar);
           
            ratio_1       =   meanc(rt_1)';
            ratio_2       =   meanc(rt_2)';

            
            /*storing */

            aratio1[j,.] =  ratio_1;       
            aratio2[j,.] =  ratio_2;
           /* if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;*/
            j = j+1;          
        endo;
  //aratio2[.,3];
    /*write output*/
  
    wr = writer(fhratiototal1,aratio1);
    wr = writer(fhratiototal2,aratio2);

 endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhratiototal1, fhratiototal2;



/*Providing results: RATIOS*/

/*open the output file*/

open fhratiototal1 =  ^oratiototal1 for read;
nburn=1;
drawrow = readr(fhratiototal1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiototal1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiototal1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   /*if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiototal1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiototal1, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiototal1,nburn);
   drawblock = readr(fhratiototal1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiototal1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiototal1);

   endo;

  /* if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
"===========================================================";
"CHANGES IN ALL RELEVANT PARAMETERS";
"===========================================================";

    "RATIO 1";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

/**period 2**/
open fhratiototal2 =  ^oratiototal2 for read;
nburn=1;
drawrow = readr(fhratiototal2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhratiototal2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhratiototal2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

  /* if _verbose;
      ".";;pause(1e-20);
   endif;
*/
   eofloop = eof(fhratiototal2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y I N H W pi R C xp
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhratiototal2, nburn);
drawci  = zeros(2,drawdim);

/*if _verbose;
   "";
   "Part 2: HPD Interval";
endif;
*/
j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhratiototal2,nburn);
   drawblock = readr(fhratiototal2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhratiototal2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhratiototal2);

   endo;

   /*if _verbose;".";;pause(1e-20);endif;*/

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";
    "RATIO 2";
   outmat = ("Stdev"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;
closeall fhpara, fhratiototal1, fhratiototal2;
end;









/*********************************************/
/*********************************************/
proc(3) = dsgesim_2(para1,pmsel,Tsimburn,Tsimtotal);
local TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ, 
      HHchol,QQchol,neps,nstate,ny, 
      yt,st,epst,t,
      TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2,HHchol2,QQchol2,
      ssteady1,ssteady2;
     
/*System matrices for the state-space representation*/
     
    {TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}            = sysmat_3(para1, msel);
    

ssteady1  =  sysmat_ssteady_sub(para1,msel);
neps    =   cols(QQ);
nstate  =   cols(TT);
ny      =   rows(ZZ);

QQchol  =   chol(QQ)';
HHchol  =   cholpsd(HH);  /**Recall that HH=zeros since we are not considering measurement errors**/

/*Simulating the DSGE model*/
 yT     =   zeros(Tsimtotal-Tsimburn,ny);
 st     =   ssteady1[1:46];/*zeros(nstate,1);*/
 
 t  =   1;
 do until t > Tsimtotal-Tsimburn;
        epst    =   QQchol*rndn(neps,1);
        st      =   JJ + TT*st + RR*epst;
        /*yT[t,.] =   DD' + (ZZ*(st-JJ))' + (HHchol*rndn(ny,1))';*/
        yT[t,.] =    (ZZ*st)' + (HHchol*rndn(ny,1))';
    t       =   t+1;
 endo;
 
yT = yT[1:Tsimtotal-Tsimburn,.];


 retp(yT, RC, RC);
 endp;

/********************************************************************/
proc(1) = hpdint(draws,percent);

local ndraws,drawdim,hpdband,nwidth,i,drawcoli,bup,minwidth,newwidth,j;

drawdim = cols(draws);
ndraws  = rows(draws);
hpdband = zeros(2,drawdim);
nwidth  = int(percent*ndraws);

i = 1;
do until i> drawdim;
    drawcoli = draws[.,i];
    /*sort response for period i, element 1 is max*/
     drawcoli   = rev(sortc(drawcoli,1));
     bup        = 1;
     minwidth   = drawcoli[1] - drawcoli[nwidth];
     j = 2;
     do until j > (ndraws-nwidth+1);
        newwidth    =  drawcoli[j] - drawcoli[j+nwidth-1];
        if newwidth < minwidth;
            bup = j;
            minwidth    = newwidth;
        endif;
        j = j+1;
    endo;
    hpdband[2,i]    = drawcoli[bup];
    hpdband[1,i]    = drawcoli[bup+nwidth-1];
    i = i+1;
endo;
retp(hpdband);
endp;


/*********************************************/
proc(3) = dsgesim_3(para1,pmsel,Tsimburn,Tsimtotal);
local TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ, 
      HHchol,QQchol,neps,nstate,ny, 
      yt,st,epst,t,
      TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2,HHchol2,QQchol2,
      ssteady1,ssteady2;
     
/*System matrices for the state-space representation*/
     
    {TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}            = sysmat_3(para1, msel);
    

ssteady1  =  sysmat_ssteady_sub(para1,msel);
neps    =   cols(QQ);
nstate  =   cols(TT);
ny      =   rows(ZZ);

QQchol  =   chol(QQ)';
HHchol  =   cholpsd(HH);  /**Recall that HH=zeros since we are not considering measurement errors**/

/*Simulating the DSGE model*/
 yT     =   zeros(Tsimtotal-Tsimburn,ny);
 st     =   ssteady1;/*zeros(nstate,1);*/
 
 t  =   1;
 do until t > Tsimtotal-Tsimburn;
        epst    =   QQchol*rndn(neps,1);
        st      =   JJ + TT*st + RR*epst;
        /*yT[t,.] =   DD' + (ZZ*(st-JJ))' + (HHchol*rndn(ny,1))';*/
        yT[t,.] =    (ZZ*st)' + (HHchol*rndn(ny,1))';
    t       =   t+1;
 endo;
 
yT = yT[1:Tsimtotal-Tsimburn,.];


 retp(yT, RC, RC);
 endp;




/*********************************************************/
proc(1) = hpfilter(y,w);

local t,a,b,c,d,m,i,j,shp;

    t       = rows(y);
    a       = 6*w+1;
    b       = -4*w;
    c       = w;
    d 	    = c~b~a;

d       = ones(t,1)*d;

d[1,1]=0;
d[2,1]=0;
d[1,2]=0;

d[2,2] = -2*w;
d[t,2] = -2*w;

d[1,3] = 1+w;
d[t,3] = 1+w;

d[2,3]=5*w+1;
d[t-1,3]=5*w+1;

@ The Smoothed Series @

shp = bandsolpd(eye(t),d)*y;

retp(shp);
endp;







/********************************************************************
**      System matrices for state-space representation with DDcoint
**
**      {TT,QQ,RR,HH,DD,ZZ,VV,Z_t,RC,code_nsp}=sysmat(para,msel);                
********************************************************************/
proc (9) = sysmat_3(para,msel);
    local T1, TC, T0, TETA, RC, TT, QQ, RR, HH, ZZ, DD,VV, ny, nz, nep, nstate, retcode,
          eq_gva, eq_inv, eq_lev, eq_h, eq_pi, eq_ffr, eq_ls,v_w,y_star,w_star,log_ystar,log_wstar,
          v_y, v_i, v_rn, v_nw, v_h, v_pi, v_z,v_chi,log_chistar,k34,v_debtlag,v_Erk,log_cstar,
log_istar,k_star,log_kstar,
log_nstar,e_z, e_zeta, e_gam, e_r, e_mark, e_theta,e_mu,d_star,nw_star,eq_debt,v_wlag,rk_Star,eq_k,v_k,v_klag,
          v_ylag, v_ilag, n_lag,v_nwlag,eq_nw,e_b,sigma_b,JJ,ssteady_partial,eq_c,v_c,v_clag,c_star,i_star,n_star,v_q,
          lnratio_star,ratio_star,h_star,log_hstar,pi_star,beta,upsilon_z,sigma_z,sigma_zeta,sigma_gam,sigma_mu,sigma_r,sigma_mark,sigma_theta,
          log_pi,log_sc_z,log_rn,sc_z_star,steady,valid_cy,valid_cy_1,valid_cy_2,rn_star,eq_d,eq_xp,v_rk,v_rlag,v_d,v_r,r_star,v_dlag, log_rk,
          e_g,sg,v_xp,xp_star;





/**Solve DSGE model**/
{T1,TC,T0,TETA,RC,retcode} = dsgesolv(para,msel);
/*print "T1";
T1;
print "T0";s
T0;
*/
/**Observation indices**/
if (msel==11);
    eq_gva  =   1;
    eq_inv  =   2;
    eq_nw   =   3;
    eq_h    =   4;
    eq_ls    =  5;
    eq_pi   =   6;
    eq_ffr  =   7;
    eq_c    = 8;
    eq_xp   =   9;
    ny      =   9;
endif;

/**variable indices**/
v_y     =   1;
v_i     =   3;
v_rn    =   8;
v_h     =   10;
v_w     =   11;
v_pi    =   13;
v_nw    =   15;
v_z     =   20;
v_d     =   4;
v_c     =   2;
v_Erk   =   37;   
v_r     =   7;

/**Shock indices**/
if (msel==11) or (msel==31);
    e_z      = 1;
    e_zeta   = 2;
    e_mu   = 3;
    e_mark   = 4;
    e_theta  = 5;
    e_b      = 6;
    e_gam    = 7;
    e_r      = 8;
    e_g      = 9;
endif;

/**names to parameters**/
{steady,valid_cy,valid_cy_1,valid_cy_2}=getpara(para,msel);

   
pi_star         =   steady[5];    
beta            =   steady[6];
upsilon_z       =   steady[22];
log_hstar       =   steady[8];
y_star          =   steady[67];
w_star          =   steady[68];
rn_star         =   steady[50];
rk_star         =   steady[52];
r_star          =   steady[51];
xp_star         =   steady[46];

c_star          =   steady[71]*y_star;
i_star          =   steady[61]*steady[64];
n_star          =   steady[65];
    

log_sc_z        =   upsilon_z;
log_rn          =   ln(rn_star);
log_pi          =   ln(pi_star);
log_ystar	    =   ln(y_star);
log_wstar       =   ln(w_star);
log_cstar       =   ln(c_star);
log_istar       =   ln(i_star);
log_nstar       =   ln(n_star);
log_rk          =   ln(rk_star);


sigma_z         =   steady[24];
sigma_zeta      =   steady[25];
sigma_mu        =   steady[26];
sigma_mark      =   steady[27];
sigma_theta     =   steady[28];
sigma_b         =   steady[29];
sigma_gam       =   steady[30];
sigma_r         =   steady[31];
sg              =   steady[41];
/*************************************************
**       Transition equations with augmentation
**
**       z(t) = T1*z(t-1) + T0*e(t)
**       x(t) = [z(t)',...]'
**
**       x(t) = TT*x(t-1) + RR*e(t)
**       e(t) ~ iid N(0,QQ)
*************************************************/
nz  = cols(T1);
nep = cols(T0);


TT = zeros(nz,nz);

TT[1:nz,1:nz]       = T1;

QQ                  = zeros(nep,nep);
QQ[e_z,e_z]         = sigma_z^2;
QQ[e_zeta,e_zeta]   = sigma_zeta^2;
QQ[e_mu,e_mu]       = sigma_mu^2;
QQ[e_mark,e_mark]   = sigma_mark^2;
QQ[e_theta,e_theta] = sigma_theta^2;
QQ[e_r,e_r]         = sigma_r^2;
QQ[e_b,e_b]         = sigma_b^2;
QQ[e_gam,e_gam]     = sigma_gam^2;
QQ[e_g,e_g]         = sg^2;

RR = T0;

ssteady_partial     = sysmat_ssteady_sub(para,msel);
JJ = (eye(cols(TT)) - TT) *(ssteady_partial[1:rows(ssteady_partial)-6]);
/*************************************************
** Measurement equations
**
*************************************************/
nstate = cols(TT);

DD = zeros(ny,1);    

DD[eq_gva,1]    = log_sc_z+log_ystar;
DD[eq_inv,1]    = log_sc_z+log_istar;
DD[eq_nw,1]     = log_sc_z+log_nstar;
DD[eq_h,1]      = log_hstar;
DD[eq_ls,1]     = log_sc_z+log_wstar;
DD[eq_pi,1]     = log_pi;//0;//
DD[eq_ffr,1]    =  log_rn; //log_rk - log_rn;   //  
DD[eq_c,1]   = log_sc_z+log_cstar;//log_sc_z+log_kstar;//
DD[eq_xp, 1]  = ln(1+xp_star);//log_rk - log_rn;

ZZ = zeros(ny,nstate);

ZZ[eq_gva,v_y]      =  1;
ZZ[eq_gva,v_z]      =  1;

ZZ[eq_inv,v_i]      =  1;
ZZ[eq_inv,v_z]      =  1;

ZZ[eq_nw,v_nw]      =  1;
ZZ[eq_nw,v_z]       =  1;

ZZ[eq_h, v_h]      = 1;

// wage growth
ZZ[eq_ls,v_w]        =  1;
ZZ[eq_ls,v_z]        =  1;


ZZ[eq_pi,v_pi]      =  1;

ZZ[eq_ffr,v_rn]     =  1;

ZZ[eq_c,v_c]      =  1;
ZZ[eq_c,v_z]       =  1;

ZZ[eq_xp,v_Erk]    = rk_star/(1+xp_star);  
ZZ[eq_xp,v_r]     =  -r_star/(1+xp_star);  

HH = zeros(ny,ny);  /** w/o measurement error **/

/*print "DD";
DD;
print "ZZ";
ZZ';*/
VV = zeros(nep,ny);

retp(TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ);
endp;






