/******************************************************************************
* LOADDATA.G
* reads time series data from ASCII data set into Gauss variable YY
* Data: Output growth, Investment growth, Leverage ratio, Federal Funds Rate
*
* updated: 05:42 PM  04-Aug-2008
******************************************************************************/

/**Loading data containing the observables to be compared with the implied states**/

/*  load path   = ^datapath YYallstates[]= "states.txt";
  YYallstates = reshape(YYallstates,rows(YYallstates)/6,6);
  YYstates    = YYallstates[.,1:6];
*/

/**Loading the data to be used for estimation**/
 
  load path   = ^datapath YYall[]= "whole.txt";
  YYall       = reshape(YYall,rows(YYall)/9,9);
  YY          = YYall[.,1:9];
  /*We use inflation rate at quarterly rates*/
  YY6         = ln(1+YY[.,6]/400);
  YY[.,6]     = YY6;
  /*In our model interest rates are defined in gross terms. We will use 
  ffr in levels (data are in %) and in gross terms*/  
  YY7         =  ln(1+YY[.,7]/400);
  YY[.,7]     = YY7;
               
  YY9         =  ln(1+YY[.,9]/400);
  YY[.,9]     = YY9;

  ti          = seqa(1953.75,0.25,rows(YY));
  nobs        = rows(YY);
  
  if (br == 84);              
      if (datasel == 2);
          Y1   =  YY[1:118,.];  
          YY   =  Y1;    
          ti   = seqa(1953.5,0.25,rows(YY));
          nobs = rows(YY);
       elseif (datasel == 3);
          Y2   =  YY[119:nobs,.];      
          YY   =  Y2;
          ti   = seqa(1984,0.25,rows(YY));
          nobs = rows(YY);
       endif;
  elseif (br==7284);
      if (datasel == 4);
          Y4   = YY[1:70,.];   
          YY   = Y4;  
          ti   = seqa(1953.5,0.25,rows(YY));
          nobs = rows(YY);
      elseif (datasel == 2);
          Y1   =  YY[71:118,.];  
          YY   =  Y1;    
          ti   = seqa(1972,0.25,rows(YY));
          nobs = rows(YY);
       elseif (datasel == 3);
          Y2   =  YY[119:nobs,.];      
          YY   =  Y2;
          ti   = seqa(1984,0.25,rows(YY));
          nobs = rows(YY);
       endif;
  endif;