new;
closeall;
library pgraph, user;
cls;
outwidth 256;

/*format /mat /on /mb1/ ros 16,8;*/

/*Global defaults*/
__output = 1;
_fcmptol = 1E-10;
_verbose = 1;

/** The following lines are model specific**/

nvar        =   9;
nshocks     =    9;

#include bgg_spec.g;
#include bgg_mod.src;
#include bgg_para.src;
#include pathspec.g;
#include loaddata.g;




/* Number of initial draws to be discarded 
** use nburn = 1 for draws from prior
** use the equivalent of 20 percent for draws from posterior */

hpdprob     = 0.95;
block_size  = 0.8*(150*2500);
nburn=.2*(150*2500);

mhrun = "1";

/** parameter name **/
{para,para_names} = psel(miss(0,0),msel);

   #ifos2win
        lpath  = parapath $+ "\\mhrun" $+ mhrun;
        opath  = parapath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath  = parapath $+ "/mhrun" $+ mhrun;
        opath  = parapath $+ "/mhrun" $+ mhrun;
   #endif

chkdir = chk_dir(opath);

   #ifos2win
        ldraw  = lpath $+ "\\pa.dat"  ;
        odraws = opath $+ "\\pas.dat" ;
   #endif 
  
   #ifunix 
        ldraw  = lpath $+ "/pa.dat"  ;
        odraws = opath $+ "/pas.dat" ;
   #endif


/********************************************************
* Computes posterior mean and std and CI 
********************************************************/
#include p_parapmom_median.g;

para = drawmedian;


smoothed = dsgefilt_states(para, msel, YY, _tstar_1,_tstar_2);

def_prob_star   =   para[1];
sigma_omega     =   para[29];

 _a=def_prob_star;
        _b=sigma_omega;
              eqSolveSet;
         gausset;__output=0;
	     if sigma_omega < 0.02;
            {omegabar_star,retcode}= eqSolve(&f,2);
       elseif sigma_omega >= 0.02; 
           if sigma_omega < 0.07;
            {omegabar_star,retcode}= eqSolve(&f,2);
            elseif (sigma_omega >= 0.07);
                if sigma_omega <=0.79;
                    {omegabar_star,retcode}= eqSolve(&f,.75);
                elseif sigma_omega > 0.79;
					if sigma_omega <= 1;
                        {omegabar_star,retcode}= eqSolve(&f,.4);
				    elseif sigma_omega>1;
						if sigma_omega<=1.6;
						{omegabar_star,retcode}= eqSolve(&f,.05);//eqSolve(&f,.1);
					elseif sigma_omega > 1.6;
						omegabar_Star=0.0001;
						endif;
						endif;
                endif;
            endif;
        endif;  
   __output=1;
   
//omega = ln(omegabar_star) + smoothed[.,16];
//varphi = (omega +.5*para[29]^2)/para[29];
//default1= cdfn(varphi);
//default2= .5+.5*erf(((omega)+0.5*sigma_omega^2)/(sigma_omega*sqrt(2)));
/***********************************************************************/
proc (1) = dsgefilt_states(para, msel, YY, t_star_1,t_star_2);
/* This procedure filters the statevector for the DSGE model
*/
local TT, QQ, RR,HH, DD, ZZ, VV, RC,ssteady,
      gamA, gamV, alp, npara,lambda,theta,rho_mu,rho_lambda,rho_theta,
      GA0, GA1, Pt, Pt1, Phat, At, At1, alphahat, yhat, nut, Ft,
      t, loglh, valid, nobs,detFT, invFT, la, v, k, Ptzero, tst, ptnlsys, jc, retc, fcnval, nret,  
      Siguu, sigvv, sigee, sigve, meanret,ptforward, atforward, at1_m, at1_sim, 
      yhat_m, yhat_sim, alphahat_m, alphahat_sim,u_svd, v_svd, s_svd, i, invvaralpha, varalpha,
      statesim, statemean, statevar, retcode, retcodel, nstate, kentry,
      retcodeX, XX,Upsilon_z,Upsilon_zeta,mu,neutral_accumulated,inv_accumulated,
      a_tsmoothed, zeta_tsmoothed, mu_smoothed, lambda_smoothed, theta_smoothed, r_smoothed,
      nw_smoothed, y_smoothed, d_smoothed, i_smoothed, ls_smoothed, ta_smoothed, q_smoothed, k_smoothed,w_smoothed,h_smoothed,

	  para_1,para_2,para_3,TT2,TT3,QQ2,QQ3,RR2,RR3,HH2,HH3,DD2,DD3,ZZ2,ZZ3,VV2,VV3,RC2,RC3,JJ2,JJ3,JJ,ssteady1,ssteady2,ssteady3,Pt1old,

	  varalpha2,varalpha3,invvaralpha2,invvaralpha3,xp_smoothed,delta_i,delta_y,delta_n,xp_level,obssim,obsmean, y_level,i_level,

	  nw_level,k34,y_cycle, i_cycle,nw_cycle;

nobs = rows(YY);
npara = rows(para);

/* assign names to relevant parameters */
Upsilon_z       = para[28];         

/* solve DSGE model*/

para_1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70]|para[73:74];
para_2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70]|para[73:74];
para_3     = para[1:2]|para[5:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70]|para[73:74];


{TT,QQ,RR,HH,DD,ZZ,VV,RC,JJ}           = sysmat(para_1,msel);
{TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2}   = sysmat(para_2,msel);
{TT3,QQ3,RR3,HH3,DD3,ZZ3,VV3,RC3,JJ3}   = sysmat(para_3,msel);
{ssteady1,ssteady2,ssteady3,ssteady}         = sysmat_ssteady(para,msel);

nstate = cols(TT);      /* number of state variables */ 

/* We can now define the initial mean and variance for the state vector*/

/* initial mean and variance for the state vector */
/*At = zeros(nstate,1);*/
At = ssteady1;
Pt = dlyap(TT,RR*QQ*RR');

/* compute likelihood with Kalman filter*/
Atforward = zeros(nobs,nstate);
Ptforward = zeros(nobs,nstate^2);

t = 1;
do until t > nobs;
  
   At1 = At;
   Pt1 = Pt;   

   /* Forecasting */
   if t < t_star_1;
       alphahat = TT*At1 + JJ;
       Phat = TT*Pt1*TT' + RR*QQ*RR';
       yhat = ZZ*alphahat;    
   endif;
   if t >= t_star_1 and t < t_Star_2;
       if t == t_star_1;
            alphahat = TT2*At1 + JJ2 + TT2*(ssteady2 - ssteady1);
      elseif t<t_star_2;
           alphahat = TT2*At1 + JJ2;
      endif;
      Phat = TT2*Pt1*TT2' + RR2*QQ2*RR2';
       yhat = ZZ2*alphahat;     
   endif;

   if  t >= t_Star_2;
       if t == t_star_2;
            alphahat = TT3*At1 + JJ3 + TT3*(ssteady3 - ssteady2);
      elseif t>t_Star_2;
           alphahat = TT3*At1 + JJ3;
      endif;
      Phat = TT3*Pt1*TT3' + RR3*QQ3*RR3';
       yhat = ZZ3*alphahat;      

   endif;

   nut  = YY[t,.] - yhat';
   if t<t_Star_1;   
        Ft   = ZZ*Phat*ZZ' ;
   endif;
   if t>=t_star_1 and t < t_star_2;
        Ft   = ZZ2*Phat*ZZ2' ;
   endif;
   if  t >= t_star_2;
        Ft   = ZZ3*Phat*ZZ3' ;
   
   endif;
   Ft   = 0.5*(Ft + Ft');
   
   detFt = det(Ft);
   invFt = inv_pseudo(Ft);

   /* Updating: the breakdown here is not necessary! */
   if t < t_Star_1;
       At = alphahat + (Phat*ZZ' )*inv(Ft)*nut';
       Pt = Phat - (Phat*ZZ')*inv(Ft)*(Phat*ZZ')';
   endif;  
  if t>=t_star_1 and t < t_star_2;
       At = alphahat + (Phat*ZZ2' )*inv(Ft)*nut';
       Pt = Phat - (Phat*ZZ2')*inv(Ft)*(Phat*ZZ2')';
  endif;
  if t >= t_star_2;
       At = alphahat + (Phat*ZZ3' )*inv(Ft)*nut';
       Pt = Phat - (Phat*ZZ3')*inv(Ft)*(Phat*ZZ3')';

  endif;
   Pt = symmat(Pt);   
   if t < t_star_1;
        Atforward[t,.] = At' - ssteady1';
   endif;
   if t>=t_star_1 and t < t_star_2;
        Atforward[t,.] = At' - ssteady2';
   endif;
   if t >= t_star_2;
        Atforward[t,.] = At' - ssteady3'; 
   endif;
/*"atfroward";
atforward[t,.];*/
   Ptforward[t,.] = vec(Pt)';
   t = t+1;
 endo;  
/*eofdsgefilt:   */

/* Backward application of Kalman Filter*/
statesim  = zeros(nobs,nstate);
statemean = zeros(nobs,nstate);
statevar  = zeros(nobs,nstate);



obssim    = zeros(nobs,rows(yhat));
obsmean   = zeros(nobs,rows(yhat));


y_level     = zeros(nobs,1);

i_level     = zeros(nobs,1);

nw_level    = zeros(nobs,1);




/* The last observation can be drawn
** from the final distribution of the forward filter*/
/*Atforward;
k34=keyw;*/
At = Atforward[nobs,.]';
Pt = reshape(Ptforward[nobs,.],nstate,nstate);

statemean[nobs,.] = At';
statevar[nobs,.]  = ( diag(Pt) )';
statesim[nobs,.]  = ( At + cholpsd(Pt)*rndn(nstate,1) )';

obssim[nobs,.]	  = (ZZ*statesim[nobs,.]'+ DD)';

obsmean[nobs,.]   = (ZZ*statemean[nobs,.]'+ DD)';


Pt1old=Pt;
t = nobs-1;
do until t < 1;

   At = Atforward[t,.]';
   Pt = reshape(Ptforward[t,.],nstate,nstate);
 
   /* Compute 
   **    alpha(t) cond on alpha(t+1) and Y(t)
   **    y(t+1)   cond on alpha(t+1) and Y(t)
   */
   if t >= t_star_2;
        varalpha3     =  TT3*Pt*TT3' + RR3*QQ3*RR3';
      invvaralpha3 = inv_pseudo(varalpha3);
   endif;
   if t>=t_star_1 and t < t_star_2;
        varalpha2     =  TT2*Pt*TT2' + RR2*QQ2*RR2';
         invvaralpha2 = inv_pseudo(varalpha2);
  endif;
  if t_star_1 > t;
        varalpha     =  TT*Pt*TT' + RR*QQ*RR';
        invvaralpha  = inv_pseudo(varalpha);

   endif;
   t;
  
   if t >= t_star_2;
       alphahat_m   =  At + Pt*TT3'*invvaralpha3*(statemean[t+1,.]' - TT3*At);
       alphahat_sim =  At + Pt*TT3'*invvaralpha3*(statesim[t+1,.]'  - TT3*At) ;
   
       Pt1=Pt+Pt*TT3'*invvaralpha3*(Pt1old-varalpha3)*TT3*Pt';
      yhat_m       =  ZZ2*statemean[t+1,.]' + DD3;

       yhat_sim     =  ZZ2*statesim[t+1,.]'  + DD3;
endif;
if t<t_star_2 and t >= t_star_1;
       alphahat_m   =  At + Pt*TT2'*invvaralpha2*(statemean[t+1,.]' - TT2*At);
       alphahat_sim =  At + Pt*TT2'*invvaralpha2*(statesim[t+1,.]'  - TT2*At) ;
       
       Pt1=Pt+Pt*TT2'*invvaralpha2*(Pt1old-varalpha2)*TT2*Pt';
      yhat_m       =  ZZ2*statemean[t+1,.]' + DD2;
       yhat_sim     =  ZZ2*statesim[t+1,.]'  + DD2;
endif;
   if t < t_Star_1; 
       alphahat_m   =  At + Pt*TT'*invvaralpha*(statemean[t+1,.]' - TT*At);
       alphahat_sim =  At + Pt*TT'*invvaralpha*(statesim[t+1,.]'  - TT*At) ;
    
       Pt1=Pt+Pt*TT'*invvaralpha*(Pt1old-varalpha)*TT*Pt';
      yhat_m       =  ZZ*statemean[t+1,.]' + DD;
       yhat_sim     =  ZZ*statesim[t+1,.]'  + DD;
  
   endif;
   statemean[t,.] = alphahat_m';
   statesim[t,.]  = (alphahat_sim + cholpsd(Pt1)*rndn(nstate,1))';
   statevar[t,.]  = diag(Pt1)';

   

   if t >= t_star_2;

	    obssim[t,.]	  = (ZZ3*statesim[t,.]'+ DD3)';

        obsmean[t,.]   = (ZZ3*statemean[t,.]'+ DD3)';


   endif;

   if t<t_star_2 and t >= t_star_1;

		obssim[t,.]	  = (ZZ2*statesim[t,.]'+ DD2)';

		obsmean[t,.]   = (ZZ2*statemean[t,.]'+ DD2)';


   endif;

   if t < t_Star_1; 

		obssim[t,.]	  = (ZZ*statesim[t,.]'+ DD)';

		obsmean[t,.]  = (ZZ*statemean[t,.]'+ DD)';

   endif;

   
Pt1old=Pt1;
t=t-1;
endo;

//retp(obsmean);
retp(statemean);
endp;




/**************************************************************************************/

/*Computing the pseudo-inverse of a positive semidefinite matrix controling for the tolerance
  in the SVD*/
proc(1) = inv_pseudo(varalpha);
local u_svd,s_svd,v_svd, i, nstate, rank_varalpha, 
      invvaralpha, old_svdtol, k34;

  nstate = rows(varalpha);
  old_svdtol = _svdtol;
  /*_svdtol = 1e-8;*/
_svdtol = 1e-5;
  {u_svd,s_svd,v_svd} = svd1(varalpha);
  i = 1;
  rank_varalpha = 12;/*rank(varalpha);*/
/*rank_varalpha;k34=keyw;"======================";
*/
  _svdtol = old_svdtol;
  do until i > nstate;
    if i > rank_varalpha;
             s_svd[i,i] = 0;
    else;
             s_svd[i,i] = 1/s_svd[i,i];
    endif;
    i = i+1;
  endo;
  invvaralpha = u_svd*s_svd*u_svd';

  retp(invvaralpha);
endp;




/**************************************************/

proc(1) = hpfilter(y,w);

local t,a,b,c,d,m,i,j,shp;

    t       = rows(y);
    a       = 6*w+1;
    b       = -4*w;
    c       = w;
    d 	    = c~b~a;

d       = ones(t,1)*d;

d[1,1]=0;
d[2,1]=0;
d[1,2]=0;

d[2,2] = -2*w;
d[t,2] = -2*w;

d[1,3] = 1+w;
d[t,3] = 1+w;

d[2,3]=5*w+1;
d[t-1,3]=5*w+1;

@ The Smoothed Series @

shp = bandsolpd(eye(t),d)*y;

retp(shp);
endp;


/*************************************/

proc f(omegabar_star);
    local y;
     y=_a-.5-.5*erf((ln(omegabar_star)+0.5*_b^2)/(_b*sqrt(2)));
 //    if y<0;
 //       y=0;
 //    endif;
retp(y);
endp;

