new;
closeall;
library pgraph, user;
cls;
outwidth 256;

/*format /mat /on /mb1/ ros 16,8;*/

/*Global defaults*/
__output = 1;
_fcmptol = 1E-10;
_verbose = 1;

/** The following lines are model specific**/

nvar        =   9;
nshocks     =    9;

#include bgg_spec.g;
#include bgg_mod.src;
#include bgg_para.src;
#include pathspec.g;



/***************************************
load parameters draws from MH output
****************************************/

mhrun       =   "2";
nblock      =   10000;  /*block size*/
nuse        =   5000;    /*use every nuse observation*/

   #ifos2win
        lpath       =   parapath $+ "\\mhrun" $+ mhrun;
        opath       =   resupath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath       =   parapath $+ "/mhrun" $+ mhrun;
        opath       =   resupath $+ "/mhrun" $+ mhrun;
   #endif

chkdir      =   chk_dir(opath);

   #ifos2win
        lpara       =   lpath $+ "\\pa.dat";
   #endif 
  
   #ifunix 
        lpara       =   lpath $+ "/pa.dat";
   #endif


open fhpara =  ^lpara for read;

/*check dimensions*/
para        =   pmsv(msel,datasel);
npara       =   rows(para);

/** initialize output files **/
   #ifos2win
        ospec1     = opath $+ "\\vdfreq1.dat";
        odraws1    = opath $+ "\\vdfreqmoments1.dat";
        ospec2     = opath $+ "\\vdfreq2.dat";
        odraws2    = opath $+ "\\vdfreqmoments2.dat";
        ospec3     = opath $+ "\\vdfreq3.dat";
        odraws3    = opath $+ "\\vdfreqmoments3.dat";
   #endif 
  
   #ifunix 
        ospec1     = opath $+ "/vdfreq1.dat";
        odraws1    = opath $+ "/vdfreqmoments1.dat";
        ospec2     = opath $+ "/vdfreq2.dat";
        odraws2    = opath $+ "/vdfreqmoments2.dat";
        ospec3     = opath $+ "/vdfreq3.dat";
        odraws3    = opath $+ "/vdfreqmoments3.dat";
   #endif



create fhspec1 = ^ospec1 with SPEC, nvar*nshocks, 8;
create fhspec2 = ^ospec2 with SPEC, nvar*nshocks, 8;
create fhspec3 = ^ospec3 with SPEC, nvar*nshocks, 8;

/** specify grid for omega **/
/** for business cycle frequencies(6-32 quarters) use 0.0625*pi to 0.33*pi **/
/** for period between 2-5 quarters use 0.4*pi to pi **/
/** for period between 33-64 quarters use 0.0333*pi to 0.0606*pi **/

om_min   =0.0625*pi;@0.0625*pi;@ @.0506*pi;@/*.4*pi;.0333*pi;*/
om_max   = .33*pi;@0.33*pi;@@.0606*pi;@/*pi;.0606*pi;*/
om_n     = 501;@101;@
om_step  = (om_max-om_min)/(om_n-1);
om_grid  = seqa(om_min,om_step,om_n);



/*Initialization*/
eofloop      = 0;
loopct       = 1;

if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;

do until eofloop;
    if _verbose;
    "";
    "Block          " ftos(loopct, "%*.*lf",6,0);
    endif;

    /*Read blocks of size nblock*/
    parasim     =   readr(fhpara,nblock);
    nread       =   rows(parasim);

   /*Use every nuse-th draw
    indseq      =   seqa(1,1,nread);
    indseq      =   indseq % nuse;
    indseq      =   indseq . ne 0;*/
   indseq  = seqa(1,1,nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;


    parasim     =   delif(parasim,indseq);
    nread       =   rows(parasim);

    if ismiss(parasim) == 0;
        acsim1      =   zeros(nread,nvar*nshocks);
        acsim2      =   zeros(nread,nvar*nshocks);
        acsim3      =   zeros(nread,nvar*nshocks);
                
        j           =   1;
        do until j > nread;
            para        =   parasim[j,.]';
// Standard vdc           
//para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
//para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
//para3     = para[1:2]|para[5:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];

// Counterfactual vdc: role of monetary policy 
para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
para2     = para[1:2]|para[4]|para[6:16]|para[19]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
para3     = para[1:2]|para[5:15]|para[17]|para[20]|para[22:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];

// Counterfactual vdc: role of financial institutions 
//para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
//para2     = para[1:3]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
//para3     = para[1:2]|para[4]|para[6:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];
      
            {TT1,QQ1,RR1,HH1,DD1,ZZ1,VV1,RC1,JJ1}   =   sysmat(para1,msel);
            {TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2}   =   sysmat(para2,msel);
            {TT3,QQ3,RR3,HH3,DD3,ZZ3,VV3,RC3,JJ3}   =   sysmat(para3,msel);


            sig_chol1        =   sqrt(QQ1);
            vdspec1          =   zeros(nvar,cols(QQ1));
            varspec1         =   zeros(nvar,1);
            
            sig_chol2        =   sqrt(QQ2);
            vdspec2          =   zeros(nvar,cols(QQ2));
            varspec2         =   zeros(nvar,1);
            
            sig_chol3        =   sqrt(QQ3);
            vdspec3          =   zeros(nvar,cols(QQ3));
            varspec3         =   zeros(nvar,1);
            
            /*Compute the spectrum shock by shock*/
            i   =   1;
            do until i > cols(QQ1);
                QQi         =   sig_chol1[.,i]*sig_chol1[.,i]';
                spec_mat_i  =   dsge_spectrum(TT1,RR1,ZZ1,QQi,om_grid);
                vdspec1[.,i] =   real(om_step*sumc(spec_mat_i[1:rows(spec_mat_i)-1,.]));
                varspec1     =   varspec1 + vdspec1[.,i];
                i           =   i+1;
            endo;
            vdspec1      =   vdspec1./varspec1;
            
            acsim1[j,.]  =   vec(vdspec1)';    

            i   =   1;
            do until i > cols(QQ2);
                QQi         =   sig_chol2[.,i]*sig_chol2[.,i]';
                spec_mat_i  =   dsge_spectrum(TT2,RR2,ZZ2,QQi,om_grid);
                vdspec2[.,i] =   real(om_step*sumc(spec_mat_i[1:rows(spec_mat_i)-1,.]));
                varspec2     =   varspec2 + vdspec2[.,i];
                i           =   i+1;
            endo;
            vdspec2      =   vdspec2./varspec2;
            
            acsim2[j,.]  =   vec(vdspec2)';    

            i   =   1;
            do until i > cols(QQ3);
                QQi         =   sig_chol3[.,i]*sig_chol3[.,i]';
                spec_mat_i  =   dsge_spectrum(TT3,RR3,ZZ3,QQi,om_grid);
                vdspec3[.,i] =   real(om_step*sumc(spec_mat_i[1:rows(spec_mat_i)-1,.]));
                varspec3     =   varspec3 + vdspec3[.,i];
                i           =   i+1;
            endo;
            vdspec3      =   vdspec3./varspec3;
            
            acsim3[j,.]  =   vec(vdspec3)';    

            if _verbose;
                if fmod(j,10)==0; ".";; pause(1e-20);endif;
            endif;
        
            j = j+1;
           
        endo;
    
  //   "acsim";acsim;
    /*write output*/
    wr = writer(fhspec1,acsim1);
    wr = writer(fhspec2,acsim2);
    wr = writer(fhspec3,acsim3);

 endif;

//if _verbose;
//    "";
  //  "Draws processed" ftos(rows(acsim),"%*.*lf",6,0);
  //  "";
//endif;

loopct = loopct +1;
eofloop = eof(fhpara);
endo;

closeall fhpara, fhspec1, fhspec2, fhspec3;
//end;

/*open the output file*/

open fhspec1 =  ^ospec1 for read;
nburn=1;
drawrow = readr(fhspec1, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhspec1, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhspec1,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   if _verbose;
      ".";;pause(1e-20);
   endif;

   eofloop = eof(fhspec1);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y_z I_z N_z H_z W_z pi_z R_z C_z XP_z
               Y_zeta I_zeta N_zeta H_zeta W_zeta pi_zeta R_zeta C_zeta XP_zeta
               Y_mu I_mu N_mu H_mu W_mu pi_mu R_mu C_mu XP_mu 
               Y_p I_p N_p H_p W_p pi_p R_p C_p XP_p
               Y_w I_w N_w H_w W_w pi_w R_w C_w XP_w  
               Y_b I_b N_b H_b W_b pi_b R_b C_b XP_b 
               Y_x I_x N_x H_x W_x pi_x R_x C_x XP_x
               Y_r I_r N_r H_r W_r pi_r R_r C_r XP_r 
               Y_g I_g N_g H_g W_g pi_g R_g C_g XP_g    
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhspec1, nburn);
drawci  = zeros(2,drawdim);

if _verbose;
   "";
   "Part 2: HPD Interval";
endif;

j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhspec1,nburn);
   drawblock = readr(fhspec1,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhspec1,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhspec1);

   endo;

   if _verbose;".";;pause(1e-20);endif;

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";"para_1";
   outmat = ("Var Contribution"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

create fhdraws = ^odraws1 with DRAWSUM, drawdim, 8;
wr = writer(fhdraws, real(drawmean | drawstdd | drawcov | drawci) );
closeall fhdraws;

/****************************************************/

open fhspec2 =  ^ospec2 for read;
nburn=1;
drawrow = readr(fhspec2, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhspec2, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhspec2,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   if _verbose;
      ".";;pause(1e-20);
   endif;

   eofloop = eof(fhspec2);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y_z I_z N_z H_z W_z pi_z R_z C_z XP_z
               Y_zeta I_zeta N_zeta H_zeta W_zeta pi_zeta R_zeta C_zeta XP_zeta
               Y_mu I_mu N_mu H_mu W_mu pi_mu R_mu C_mu XP_mu 
               Y_p I_p N_p H_p W_p pi_p R_p C_p XP_p
               Y_w I_w N_w H_w W_w pi_w R_w C_w XP_w  
               Y_b I_b N_b H_b W_b pi_b R_b C_b XP_b 
               Y_x I_x N_x H_x W_x pi_x R_x C_x XP_x
               Y_r I_r N_r H_r W_r pi_r R_r C_r XP_r 
               Y_g I_g N_g H_g W_g pi_g R_g C_g XP_g    
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhspec2, nburn);
drawci  = zeros(2,drawdim);

if _verbose;
   "";
   "Part 2: HPD Interval";
endif;

j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhspec2,nburn);
   drawblock = readr(fhspec2,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhspec2,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhspec1);

   endo;

   if _verbose;".";;pause(1e-20);endif;

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";"para_2";
   outmat = ("Var Contribution"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

create fhdraws = ^odraws2 with DRAWSUM, drawdim, 8;
wr = writer(fhdraws, real(drawmean | drawstdd | drawcov | drawci) );
closeall fhdraws;

/****************************************************/

open fhspec3 =  ^ospec3 for read;
nburn=1;
drawrow = readr(fhspec3, nburn);
drawdim = cols(drawrow);
drawrow = seekr(fhspec3, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);
drawcross  = zeros(drawdim,drawdim);

eofloop = 0;
nblock  = 1000;
ndraws  = 0;

hpdprob = 0.90;

do until eofloop;

   drawblock  = readr(fhspec3,nblock);

   drawmean   = drawmean   + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';
   drawcross  = drawcross  + drawblock'*drawblock;

   ndraws = ndraws + rows(drawblock);

   if _verbose;
      ".";;pause(1e-20);
   endif;

   eofloop = eof(fhspec3);

endo;

drawmean   = drawmean/ndraws;
drawsqmean = drawsqmean/ndraws;
drawstdd   = sqrt(drawsqmean - (drawmean)^2);
drawcov    = drawcross/ndraws - drawmean'*drawmean;

draw_names = {
               Y_z I_z N_z H_z W_z pi_z R_z C_z XP_z
               Y_zeta I_zeta N_zeta H_zeta W_zeta pi_zeta R_zeta C_zeta XP_zeta
               Y_mu I_mu N_mu H_mu W_mu pi_mu R_mu C_mu XP_mu 
               Y_p I_p N_p H_p W_p pi_p R_p C_p XP_p
               Y_w I_w N_w H_w W_w pi_w R_w C_w XP_w  
               Y_b I_b N_b H_b W_b pi_b R_b C_b XP_b 
               Y_x I_x N_x H_x W_x pi_x R_x C_x XP_x
               Y_r I_r N_r H_r W_r pi_r R_r C_r XP_r 
               Y_g I_g N_g H_g W_g pi_g R_g C_g XP_g    
              };

/********************************************************************
* Part 2: HPD Interval
********************************************************************/
drawrow = seekr( fhspec3, nburn);
drawci  = zeros(2,drawdim);

if _verbose;
   "";
   "Part 2: HPD Interval";
endif;

j = 1;
do until j > drawdim;

   /** Read only the j'th column **/
   drawrow   = seekr(fhspec3,nburn);
   drawblock = readr(fhspec3,1);

   drawcol = drawblock[1,j];
   eofloop = 0;
   ndraws  = 1;

   do until eofloop;

      drawblock = readr(fhspec3,nblock);
      drawcol   = drawcol | drawblock[.,j];
      ndraws    = ndraws + rows(drawblock);
      eofloop   = eof(fhspec1);

   endo;

   if _verbose;".";;pause(1e-20);endif;

   drawci[.,j] = hpdint(drawcol,hpdprob);
   j = j+1;

endo;
clear drawcol;

/** Report **/
if _verbose;
   "";"";"para_3";
   outmat = ("Var Contribution"  $~ "Mean" $~ "Stdd" $~ "CI(LOW)" $~ "CI(HIGH)")  
         $| ( (draw_names') $~ ftocv( (drawmean' ~ drawstdd'~ drawci'),4,4));

   $outmat;

   "";
endif;

create fhdraws = ^odraws3 with DRAWSUM, drawdim, 8;
wr = writer(fhdraws, real(drawmean | drawstdd | drawcov | drawci) );
closeall fhdraws;


end;

/**************************************************************/
/*                         Procedures                         */
/**************************************************************/

proc(1) = hpdint(draws,percent);
local     ndraws, drawdim, hpdband, nwidth, i, drawcoli,
          bup, minwidth, newwidth, j;

drawdim = cols(draws);
ndraws  = rows(draws);
hpdband = zeros(2,drawdim);
nwidth  = int(percent*ndraws);

i = 1;
do until i > drawdim;
   drawcoli = draws[.,i];
   /* sort response for period i, element 1 is max
   */
   drawcoli = rev(sortc(drawcoli,1));
   bup   = 1;
   minwidth  = drawcoli[1] - drawcoli[nwidth];
   j = 2;
   do until j > (ndraws-nwidth+1);
      newwidth = drawcoli[j] - drawcoli[j+nwidth-1];
      if newwidth < minwidth;
         bup = j;
         minwidth = newwidth;
      endif;
      j = j+1;
   endo;
   hpdband[2,i] = drawcoli[bup];
   hpdband[1,i] = drawcoli[bup+nwidth-1];
   i = i+1;
endo;

retp(hpdband);
endp;
/********************************************************************
**  Compute the spectrum as a function of the system matrices
**
**  spec_mat    = spec_dsge(TT,RR,ZZ,QQ,om_grid);
**
**  Last updated: 10/21/2005 
********************************************************************/
proc (1)    = dsge_spectrum(TT,RR,ZZ,QQ,om_grid);    /** HH=0 & VV=0 **/

/** 
global intidx_, cumidx_
**/
local   om_n,nstate,ny,spec_mat,im_i,
        Sl,SD,Ddiag,Dinv,om_idx,om;
@       nr,p,d,q,TTsvd,RRsvd,Ptsvd,Pt,GAM;@

/** dimensions  **/
om_n     =  rows(om_grid);
nstate   =  rows(TT);
ny       =  rows(ZZ);

/** initialize  output **/
spec_mat    = zeros(om_n,ny);

/** imaginary unit: i **/
let im_i    = 1i;

/** spectrum density    of  y **/
/** loop    along   omega_grid_ **/

om_idx =    1;
do  until   om_idx >    om_n;

    om  = om_grid[om_idx];

    Sl  = eye(nstate)-TT*exp(-im_i*om);
    SD  = ZZ*inv(Sl)*(RR*QQ*RR')*inv(Sl')*ZZ'/2/pi;

    /*SD[1,.] = (abs(1/(1-0.999999*exp(-im_i*om))))^2*SD[1,.];    
    SD[2,.] = (abs(1/(1-0.999999*exp(-im_i*om))))^2*SD[2,.];
    SD[3,.] = (abs(1/(1-0.999999*exp(-im_i*om))))^2*SD[3,.];
*/
/*CORRECT*/
    SD[1,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[1,.];    
    SD[2,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[2,.];
    SD[3,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[3,.];
    SD[5,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[5,.];
    SD[8,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[8,.];
/* Equivalent transformation
  SD[1,.] = SD[1,.]/(1+0.999999^2-2*0.999999*cos(om));      
  SD[2,.] = SD[2,.]/(1+0.999999^2-2*0.999999*cos(om));
  SD[3,.] = SD[3,.]/(1+0.999999^2-2*0.999999*cos(om));*/
    spec_mat[om_idx,.]    = diag(SD)';

    om_idx =    om_idx+1;
endo;

retp(spec_mat);
endp;
