new;
closeall;
library pgraph, user;
cls;
outwidth 256;

/*format /mat /on /mb1/ ros 16,8;*/

/*Global defaults*/
__output = 1;
_fcmptol = 1E-10;
_verbose = 1;

/** The following lines are model specific**/

nvar        =   9;
nshocks     =    9;

#include bgg_spec.g;
#include bgg_mod.src;
#include bgg_para.src;
#include pathspec.g;




/* Number of initial draws to be discarded 
** use nburn = 1 for draws from prior
** use the equivalent of 20 percent for draws from posterior */

hpdprob     = 0.95;
block_size  = 0.8*(150*2500);
nburn=.2*(150*2500);

mhrun = "2";

/** parameter name **/
{para,para_names} = psel(miss(0,0),msel);

   #ifos2win
        lpath  = parapath $+ "\\mhrun" $+ mhrun;
        opath  = parapath $+ "\\mhrun" $+ mhrun;
   #endif 
  
   #ifunix 
        lpath  = parapath $+ "/mhrun" $+ mhrun;
        opath  = parapath $+ "/mhrun" $+ mhrun;
   #endif

chkdir = chk_dir(opath);

   #ifos2win
        ldraw  = lpath $+ "\\pa.dat"  ;
        odraws = opath $+ "\\pas.dat" ;
   #endif 
  
   #ifunix 
        ldraw  = lpath $+ "/pa.dat"  ;
        odraws = opath $+ "/pas.dat" ;
   #endif


/********************************************************
* Computes posterior mean and std and CI 
********************************************************/
#include p_parapmom_median.g;

para = drawmedian;

/** specify grid for omega **/
/** for business cycle frequencies(6-32 quarters) use 0.0625*pi to 0.33*pi **/
/** for period between 2-5 quarters use 0.4*pi to pi **/
/** for period between 33-64 quarters use 0.0333*pi to 0.0606*pi **/

om_min   =0.0625*pi;@0.0625*pi;@ @.0506*pi;@/*.4*pi;.0333*pi;*/
om_max   = .33*pi;@0.33*pi;@@.0606*pi;@/*pi;.0606*pi;*/
om_n     = 501;@101;@
om_step  = (om_max-om_min)/(om_n-1);
om_grid  = seqa(om_min,om_step,om_n);



/*Initialization*/
if _verbose;
"";
"Calculating moments...";
"-----------------------";
endif;
  para[1]=0.0075;

        
para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
para2     = para[1:2]|para[4]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
para3     = para[1:2]|para[5:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];


//para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
//para2     = para[1:2]|para[4]|para[6:16]|para[19]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
//para3     = para[1:2]|para[5:15]|para[17]|para[20]|para[22:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];

//para1     = para[1:3]|para[6:16]|para[19]|para[22:30]|para[33]|para[36]|para[39]|para[42]|para[45]|para[48]|para[51]|para[54:62]|para[63]|para[66:69]|para[70:72];
//para2     = para[1:3]|para[6:15]|para[17]|para[20]|para[22:29]|para[31]|para[34]|para[37]|para[40]|para[43]|para[46]|para[49]|para[52]|para[54:62]|para[64]|para[66:69]|para[70:72];
//para3     = para[1:2]|para[4]|para[6:15]|para[18]|para[21:29]|para[32]|para[35]|para[38]|para[41]|para[44]|para[47]|para[50]|para[53:62]|para[65]|para[66:69]|para[70:72];


            {TT1,QQ1,RR1,HH1,DD1,ZZ1,VV1,RC1,JJ1}   =   sysmat(para1,msel);
            {TT2,QQ2,RR2,HH2,DD2,ZZ2,VV2,RC2,JJ2}   =   sysmat(para2,msel);
            {TT3,QQ3,RR3,HH3,DD3,ZZ3,VV3,RC3,JJ3}   =   sysmat(para3,msel);


            sig_chol1        =   sqrt(QQ1);
            vdspec1          =   zeros(nvar,cols(QQ1));
            varspec1         =   zeros(nvar,1);
            
            sig_chol2        =   sqrt(QQ2);
            vdspec2          =   zeros(nvar,cols(QQ2));
            varspec2         =   zeros(nvar,1);
            
            sig_chol3        =   sqrt(QQ3);
            vdspec3          =   zeros(nvar,cols(QQ3));
            varspec3         =   zeros(nvar,1);
            
            /*Compute the spectrum shock by shock*/
            i   =   1;
            do until i > cols(QQ1);
                QQi         =   sig_chol1[.,i]*sig_chol1[.,i]';
                spec_mat_i  =   dsge_spectrum(TT1,RR1,ZZ1,QQi,om_grid);
                vdspec1[.,i] =   real(om_step*sumc(spec_mat_i[1:rows(spec_mat_i)-1,.]));
                varspec1     =   varspec1 + vdspec1[.,i];
                i           =   i+1;
            endo;
            vdspec1      =   vdspec1./varspec1;
            

            i   =   1;
            do until i > cols(QQ2);
                QQi         =   sig_chol2[.,i]*sig_chol2[.,i]';
                spec_mat_i  =   dsge_spectrum(TT2,RR2,ZZ2,QQi,om_grid);
                vdspec2[.,i] =   real(om_step*sumc(spec_mat_i[1:rows(spec_mat_i)-1,.]));
                varspec2     =   varspec2 + vdspec2[.,i];
                i           =   i+1;
            endo;
            vdspec2      =   vdspec2./varspec2;
            

            i   =   1;
            do until i > cols(QQ3);
                QQi         =   sig_chol3[.,i]*sig_chol3[.,i]';
                spec_mat_i  =   dsge_spectrum(TT3,RR3,ZZ3,QQi,om_grid);
                vdspec3[.,i] =   real(om_step*sumc(spec_mat_i[1:rows(spec_mat_i)-1,.]));
                varspec3     =   varspec3 + vdspec3[.,i];
                i           =   i+1;
            endo;
            vdspec3      =   vdspec3./varspec3;


cls;
   #ifos2win
        outstr = resupath $+ "\\vdc_median.txt";
   #endif 
  
   #ifunix 
        outstr = resupath $+ "/vdc_median.txt";
   #endif

output file = ^outstr reset;
"variance decomposition para1";
100*vdspec1;
"========================================================";
"variance decomposition para2";
100*vdspec2;
"========================================================";
"variance decomposition para3";
100*vdspec3;
"========================================================";
output file = ^outstr off;            

/**************************************************************/
/*                         Procedures                         */
/**************************************************************/

proc(1) = hpdint(draws,percent);
local     ndraws, drawdim, hpdband, nwidth, i, drawcoli,
          bup, minwidth, newwidth, j;

drawdim = cols(draws);
ndraws  = rows(draws);
hpdband = zeros(2,drawdim);
nwidth  = int(percent*ndraws);

i = 1;
do until i > drawdim;
   drawcoli = draws[.,i];
   /* sort response for period i, element 1 is max
   */
   drawcoli = rev(sortc(drawcoli,1));
   bup   = 1;
   minwidth  = drawcoli[1] - drawcoli[nwidth];
   j = 2;
   do until j > (ndraws-nwidth+1);
      newwidth = drawcoli[j] - drawcoli[j+nwidth-1];
      if newwidth < minwidth;
         bup = j;
         minwidth = newwidth;
      endif;
      j = j+1;
   endo;
   hpdband[2,i] = drawcoli[bup];
   hpdband[1,i] = drawcoli[bup+nwidth-1];
   i = i+1;
endo;

retp(hpdband);
endp;
/********************************************************************
**  Compute the spectrum as a function of the system matrices
**
**  spec_mat    = spec_dsge(TT,RR,ZZ,QQ,om_grid);
**
**  Last updated: 10/21/2005 
********************************************************************/
proc (1)    = dsge_spectrum(TT,RR,ZZ,QQ,om_grid);    /** HH=0 & VV=0 **/

/** 
global intidx_, cumidx_
**/
local   om_n,nstate,ny,spec_mat,im_i,
        Sl,SD,Ddiag,Dinv,om_idx,om;
@       nr,p,d,q,TTsvd,RRsvd,Ptsvd,Pt,GAM;@

/** dimensions  **/
om_n     =  rows(om_grid);
nstate   =  rows(TT);
ny       =  rows(ZZ);

/** initialize  output **/
spec_mat    = zeros(om_n,ny);

/** imaginary unit: i **/
let im_i    = 1i;

/** spectrum density    of  y **/
/** loop    along   omega_grid_ **/

om_idx =    1;
do  until   om_idx >    om_n;

    om  = om_grid[om_idx];

    Sl  = eye(nstate)-TT*exp(-im_i*om);
    SD  = ZZ*inv(Sl)*(RR*QQ*RR')*inv(Sl')*ZZ'/2/pi;

    /*SD[1,.] = (abs(1/(1-0.999999*exp(-im_i*om))))^2*SD[1,.];    
    SD[2,.] = (abs(1/(1-0.999999*exp(-im_i*om))))^2*SD[2,.];
    SD[3,.] = (abs(1/(1-0.999999*exp(-im_i*om))))^2*SD[3,.];
*/
/*CORRECT*/
    SD[1,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[1,.];    
    SD[2,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[2,.];
    SD[3,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[3,.];
    SD[5,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[5,.];
    SD[8,.] = (abs(1/(1-exp(-im_i*om))))^2*SD[8,.];
/* Equivalent transformation
  SD[1,.] = SD[1,.]/(1+0.999999^2-2*0.999999*cos(om));      
  SD[2,.] = SD[2,.]/(1+0.999999^2-2*0.999999*cos(om));
  SD[3,.] = SD[3,.]/(1+0.999999^2-2*0.999999*cos(om));*/
    spec_mat[om_idx,.]    = diag(SD)';

    om_idx =    om_idx+1;
endo;

retp(spec_mat);
endp;
